<?php
session_start(); // Initialize Session data
ob_start(); // Turn on output buffering
?>
<?php include "ewcfg7.php" ?>
<?php include "ewmysql7.php" ?>
<?php include "phpfn7.php" ?>
<?php include "p_villagesinfo.php" ?>
<?php include "userfn7.php" ?>
<?php

// Create page object
$p_villages_view = new cp_villages_view();
$Page =& $p_villages_view;

// Page init
$p_villages_view->Page_Init();

// Page main
$p_villages_view->Page_Main();
?>
<?php include "header.php" ?>
<?php if ($p_villages->Export == "") { ?>
<script type="text/javascript">
<!--

// Create page object
var p_villages_view = new ew_Page("p_villages_view");

// page properties
p_villages_view.PageID = "view"; // page ID
p_villages_view.FormID = "fp_villagesview"; // form ID
var EW_PAGE_ID = p_villages_view.PageID; // for backward compatibility

// extend page with Form_CustomValidate function
p_villages_view.Form_CustomValidate =  
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }
<?php if (EW_CLIENT_VALIDATE) { ?>
p_villages_view.ValidateRequired = true; // uses JavaScript validation
<?php } else { ?>
p_villages_view.ValidateRequired = false; // no JavaScript validation
<?php } ?>

//-->
</script>
<script language="JavaScript" type="text/javascript">
<!--

// Write your client script here, no need to add script tags.
// To include another .js script, use:
// ew_ClientScriptInclude("my_javascript.js"); 
//-->

</script>
<?php } ?>
<p><span class="phpmaker"><?php echo $Language->Phrase("View") ?>&nbsp;<?php echo $Language->Phrase("TblTypeTABLE") ?><?php echo $p_villages->TableCaption() ?>
<br><br>
<?php if ($p_villages->Export == "") { ?>
<a href="<?php echo $p_villages_view->ListUrl ?>"><?php echo $Language->Phrase("BackToList") ?></a>&nbsp;
<?php if ($Security->IsLoggedIn()) { ?>
<a href="<?php echo $p_villages_view->EditUrl ?>"><?php echo $Language->Phrase("ViewPageEditLink") ?></a>&nbsp;
<?php } ?>
<?php } ?>
</span></p>
<?php
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
$p_villages_view->ShowMessage();
?>
<p>
<table cellspacing="0" class="ewGrid"><tr><td class="ewGridContent">
<div class="ewGridMiddlePanel">
<table cellspacing="0" class="ewTable">
<?php if ($p_villages->id->Visible) { // id ?>
	<tr<?php echo $p_villages->id->RowAttributes ?>>
		<td class="ewTableHeader"><?php echo $p_villages->id->FldCaption() ?></td>
		<td<?php echo $p_villages->id->CellAttributes() ?>>
<div<?php echo $p_villages->id->ViewAttributes() ?>><?php echo $p_villages->id->ViewValue ?></div></td>
	</tr>
<?php } ?>
<?php if ($p_villages->player_name->Visible) { // player_name ?>
	<tr<?php echo $p_villages->player_name->RowAttributes ?>>
		<td class="ewTableHeader"><?php echo $p_villages->player_name->FldCaption() ?></td>
		<td<?php echo $p_villages->player_name->CellAttributes() ?>>
<div<?php echo $p_villages->player_name->ViewAttributes() ?>><?php echo $p_villages->player_name->ViewValue ?></div></td>
	</tr>
<?php } ?>
<?php if ($p_villages->village_name->Visible) { // village_name ?>
	<tr<?php echo $p_villages->village_name->RowAttributes ?>>
		<td class="ewTableHeader"><?php echo $p_villages->village_name->FldCaption() ?></td>
		<td<?php echo $p_villages->village_name->CellAttributes() ?>>
<div<?php echo $p_villages->village_name->ViewAttributes() ?>><?php echo $p_villages->village_name->ViewValue ?></div></td>
	</tr>
<?php } ?>
<?php if ($p_villages->is_capital->Visible) { // is_capital ?>
	<tr<?php echo $p_villages->is_capital->RowAttributes ?>>
		<td class="ewTableHeader"><?php echo $p_villages->is_capital->FldCaption() ?></td>
		<td<?php echo $p_villages->is_capital->CellAttributes() ?>>
<div<?php echo $p_villages->is_capital->ViewAttributes() ?>><?php echo $p_villages->is_capital->ViewValue ?></div></td>
	</tr>
<?php } ?>
<?php if ($p_villages->is_special_village->Visible) { // is_special_village ?>
	<tr<?php echo $p_villages->is_special_village->RowAttributes ?>>
		<td class="ewTableHeader"><?php echo $p_villages->is_special_village->FldCaption() ?></td>
		<td<?php echo $p_villages->is_special_village->CellAttributes() ?>>
<div<?php echo $p_villages->is_special_village->ViewAttributes() ?>><?php echo $p_villages->is_special_village->ViewValue ?></div></td>
	</tr>
<?php } ?>
<?php if ($p_villages->people_count->Visible) { // people_count ?>
	<tr<?php echo $p_villages->people_count->RowAttributes ?>>
		<td class="ewTableHeader"><?php echo $p_villages->people_count->FldCaption() ?></td>
		<td<?php echo $p_villages->people_count->CellAttributes() ?>>
<div<?php echo $p_villages->people_count->ViewAttributes() ?>><?php echo $p_villages->people_count->ViewValue ?></div></td>
	</tr>
<?php } ?>
<?php if ($p_villages->crop_consumption->Visible) { // crop_consumption ?>
	<tr<?php echo $p_villages->crop_consumption->RowAttributes ?>>
		<td class="ewTableHeader"><?php echo $p_villages->crop_consumption->FldCaption() ?></td>
		<td<?php echo $p_villages->crop_consumption->CellAttributes() ?>>
<div<?php echo $p_villages->crop_consumption->ViewAttributes() ?>><?php echo $p_villages->crop_consumption->ViewValue ?></div></td>
	</tr>
<?php } ?>
<?php if ($p_villages->resources->Visible) { // resources ?>
	<tr<?php echo $p_villages->resources->RowAttributes ?>>
		<td class="ewTableHeader"><?php echo $p_villages->resources->FldCaption() ?></td>
		<td<?php echo $p_villages->resources->CellAttributes() ?>>
<div<?php echo $p_villages->resources->ViewAttributes() ?>><?php echo $p_villages->resources->ViewValue ?></div></td>
	</tr>
<?php } ?>
<?php if ($p_villages->cp->Visible) { // cp ?>
	<tr<?php echo $p_villages->cp->RowAttributes ?>>
		<td class="ewTableHeader"><?php echo $p_villages->cp->FldCaption() ?></td>
		<td<?php echo $p_villages->cp->CellAttributes() ?>>
<div<?php echo $p_villages->cp->ViewAttributes() ?>><?php echo $p_villages->cp->ViewValue ?></div></td>
	</tr>
<?php } ?>
<?php if ($p_villages->buildings->Visible) { // buildings ?>
	<tr<?php echo $p_villages->buildings->RowAttributes ?>>
		<td class="ewTableHeader"><?php echo $p_villages->buildings->FldCaption() ?></td>
		<td<?php echo $p_villages->buildings->CellAttributes() ?>>
<div<?php echo $p_villages->buildings->ViewAttributes() ?>><?php echo $p_villages->buildings->ViewValue ?></div></td>
	</tr>
<?php } ?>
<?php if ($p_villages->troops_num->Visible) { // troops_num ?>
	<tr<?php echo $p_villages->troops_num->RowAttributes ?>>
		<td class="ewTableHeader"><?php echo $p_villages->troops_num->FldCaption() ?></td>
		<td<?php echo $p_villages->troops_num->CellAttributes() ?>>
<div<?php echo $p_villages->troops_num->ViewAttributes() ?>><?php echo $p_villages->troops_num->ViewValue ?></div></td>
	</tr>
<?php } ?>
</table>
</div>
</td></tr></table>
<p>
<?php if ($p_villages->Export == "") { ?>
<script language="JavaScript" type="text/javascript">
<!--

// Write your table-specific startup script here
// document.write("page loaded");
//-->

</script>
<?php } ?>
<?php include "footer.php" ?>
<?php
$p_villages_view->Page_Terminate();
?>
<?php

//
// Page class
//
class cp_villages_view {

	// Page ID
	var $PageID = 'view';

	// Table name
	var $TableName = 'p_villages';

	// Page object name
	var $PageObjName = 'p_villages_view';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		global $p_villages;
		if ($p_villages->UseTokenInUrl) $PageUrl .= "t=" . $p_villages->TableVar . "&"; // Add page token
		return $PageUrl;
	}

	// Page URLs
	var $AddUrl;
	var $EditUrl;
	var $CopyUrl;
	var $DeleteUrl;
	var $ViewUrl;
	var $ListUrl;

	// Export URLs
	var $ExportPrintUrl;
	var $ExportHtmlUrl;
	var $ExportExcelUrl;
	var $ExportWordUrl;
	var $ExportXmlUrl;
	var $ExportCsvUrl;

	// Update URLs
	var $InlineAddUrl;
	var $InlineCopyUrl;
	var $InlineEditUrl;
	var $GridAddUrl;
	var $GridEditUrl;
	var $MultiDeleteUrl;
	var $MultiUpdateUrl;

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		if (@$_SESSION[EW_SESSION_MESSAGE] <> "") { // Append
			$_SESSION[EW_SESSION_MESSAGE] .= "<br>" . $v;
		} else {
			$_SESSION[EW_SESSION_MESSAGE] = $v;
		}
	}

	// Show message
	function ShowMessage() {
		$sMessage = $this->getMessage();
		$this->Message_Showing($sMessage);
		if ($sMessage <> "") { // Message in Session, display
			echo "<p><span class=\"ewMessage\">" . $sMessage . "</span></p>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm, $p_villages;
		if ($p_villages->UseTokenInUrl) {
			if ($objForm)
				return ($p_villages->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($p_villages->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}

	//
	// Page class constructor
	//
	function cp_villages_view() {
		global $conn, $Language;

		// Language object
		$Language = new cLanguage();

		// Table object (p_villages)
		$GLOBALS["p_villages"] = new cp_villages();

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'view', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'p_villages', TRUE);

		// Start timer
		$GLOBALS["gsTimer"] = new cTimer();

		// Open connection
		$conn = ew_Connect();
	}

	// 
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;
		global $p_villages;

		// Security
		$Security = new cAdvancedSecurity();
		if (!$Security->IsLoggedIn()) $Security->AutoLogin();
		if (!$Security->IsLoggedIn()) {
			$Security->SaveLastUrl();
			$this->Page_Terminate("login.php");
		}

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $conn;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		 // Close connection
		$conn->Close();

		// Go to URL if specified
		$this->Page_Redirecting($url);
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();
			header("Location: " . $url);
		}
		exit();
	}
	var $lDisplayRecs = 1;
	var $lStartRec;
	var $lStopRec;
	var $lTotalRecs = 0;
	var $lRecRange = 10;
	var $lRecCnt;
	var $arRecKey = array();

	//
	// Page main
	//
	function Page_Main() {
		global $Language, $p_villages;
		$sReturnUrl = "";
		$bMatchRecord = FALSE;
		if ($this->IsPageRequest()) { // Validate request
			if (@$_GET["id"] <> "") {
				$p_villages->id->setQueryStringValue($_GET["id"]);
				$this->arRecKey["id"] = $p_villages->id->QueryStringValue;
			} else {
				$sReturnUrl = "p_villageslist.php"; // Return to list
			}

			// Get action
			$p_villages->CurrentAction = "I"; // Display form
			switch ($p_villages->CurrentAction) {
				case "I": // Get a record to display
					if (!$this->LoadRow()) { // Load record based on key
						$this->setMessage($Language->Phrase("NoRecord")); // Set no record message
						$sReturnUrl = "p_villageslist.php"; // No matching record, return to list
					}
			}
		} else {
			$sReturnUrl = "p_villageslist.php"; // Not page request, return to list
		}
		if ($sReturnUrl <> "")
			$this->Page_Terminate($sReturnUrl);

		// Render row
		$p_villages->RowType = EW_ROWTYPE_VIEW;
		$this->RenderRow();
	}

	// Set up starting record parameters
	function SetUpStartRec() {
		global $p_villages;
		if ($this->lDisplayRecs == 0)
			return;
		if ($this->IsPageRequest()) { // Validate request
			if (@$_GET[EW_TABLE_START_REC] <> "") { // Check for "start" parameter
				$this->lStartRec = $_GET[EW_TABLE_START_REC];
				$p_villages->setStartRecordNumber($this->lStartRec);
			} elseif (@$_GET[EW_TABLE_PAGE_NO] <> "") {
				$this->nPageNo = $_GET[EW_TABLE_PAGE_NO];
				if (is_numeric($this->nPageNo)) {
					$this->lStartRec = ($this->nPageNo-1)*$this->lDisplayRecs+1;
					if ($this->lStartRec <= 0) {
						$this->lStartRec = 1;
					} elseif ($this->lStartRec >= intval(($this->lTotalRecs-1)/$this->lDisplayRecs)*$this->lDisplayRecs+1) {
						$this->lStartRec = intval(($this->lTotalRecs-1)/$this->lDisplayRecs)*$this->lDisplayRecs+1;
					}
					$p_villages->setStartRecordNumber($this->lStartRec);
				}
			}
		}
		$this->lStartRec = $p_villages->getStartRecordNumber();

		// Check if correct start record counter
		if (!is_numeric($this->lStartRec) || $this->lStartRec == "") { // Avoid invalid start record counter
			$this->lStartRec = 1; // Reset start record counter
			$p_villages->setStartRecordNumber($this->lStartRec);
		} elseif (intval($this->lStartRec) > intval($this->lTotalRecs)) { // Avoid starting record > total records
			$this->lStartRec = intval(($this->lTotalRecs-1)/$this->lDisplayRecs)*$this->lDisplayRecs+1; // Point to last page first record
			$p_villages->setStartRecordNumber($this->lStartRec);
		} elseif (($this->lStartRec-1) % $this->lDisplayRecs <> 0) {
			$this->lStartRec = intval(($this->lStartRec-1)/$this->lDisplayRecs)*$this->lDisplayRecs+1; // Point to page boundary
			$p_villages->setStartRecordNumber($this->lStartRec);
		}
	}

	// Load row based on key values
	function LoadRow() {
		global $conn, $Security, $p_villages;
		$sFilter = $p_villages->KeyFilter();

		// Call Row Selecting event
		$p_villages->Row_Selecting($sFilter);

		// Load SQL based on filter
		$p_villages->CurrentFilter = $sFilter;
		$sSql = $p_villages->SQL();
		$res = FALSE;
		$rs = ew_LoadRecordset($sSql);
		if ($rs && !$rs->EOF) {
			$res = TRUE;
			$this->LoadRowValues($rs); // Load row values

			// Call Row Selected event
			$p_villages->Row_Selected($rs);
			$rs->Close();
		}
		return $res;
	}

	// Load row values from recordset
	function LoadRowValues(&$rs) {
		global $conn, $p_villages;
		$p_villages->id->setDbValue($rs->fields('id'));
		$p_villages->rel_x->setDbValue($rs->fields('rel_x'));
		$p_villages->rel_y->setDbValue($rs->fields('rel_y'));
		$p_villages->field_maps_id->setDbValue($rs->fields('field_maps_id'));
		$p_villages->image_num->setDbValue($rs->fields('image_num'));
		$p_villages->rand_num->setDbValue($rs->fields('rand_num'));
		$p_villages->parent_id->setDbValue($rs->fields('parent_id'));
		$p_villages->tribe_id->setDbValue($rs->fields('tribe_id'));
		$p_villages->player_id->setDbValue($rs->fields('player_id'));
		$p_villages->alliance_id->setDbValue($rs->fields('alliance_id'));
		$p_villages->player_name->setDbValue($rs->fields('player_name'));
		$p_villages->village_name->setDbValue($rs->fields('village_name'));
		$p_villages->alliance_name->setDbValue($rs->fields('alliance_name'));
		$p_villages->is_capital->setDbValue($rs->fields('is_capital'));
		$p_villages->is_special_village->setDbValue($rs->fields('is_special_village'));
		$p_villages->is_oasis->setDbValue($rs->fields('is_oasis'));
		$p_villages->people_count->setDbValue($rs->fields('people_count'));
		$p_villages->crop_consumption->setDbValue($rs->fields('crop_consumption'));
		$p_villages->time_consume_percent->setDbValue($rs->fields('time_consume_percent'));
		$p_villages->offer_merchants_count->setDbValue($rs->fields('offer_merchants_count'));
		$p_villages->resources->setDbValue($rs->fields('resources'));
		$p_villages->cp->setDbValue($rs->fields('cp'));
		$p_villages->buildings->setDbValue($rs->fields('buildings'));
		$p_villages->troops_training->setDbValue($rs->fields('troops_training'));
		$p_villages->troops_num->setDbValue($rs->fields('troops_num'));
		$p_villages->troops_out_num->setDbValue($rs->fields('troops_out_num'));
		$p_villages->troops_intrap_num->setDbValue($rs->fields('troops_intrap_num'));
		$p_villages->troops_out_intrap_num->setDbValue($rs->fields('troops_out_intrap_num'));
		$p_villages->troops_trapped_num->setDbValue($rs->fields('troops_trapped_num'));
		$p_villages->allegiance_percent->setDbValue($rs->fields('allegiance_percent'));
		$p_villages->child_villages_id->setDbValue($rs->fields('child_villages_id'));
		$p_villages->village_oases_id->setDbValue($rs->fields('village_oases_id'));
		$p_villages->creation_date->setDbValue($rs->fields('creation_date'));
		$p_villages->update_key->setDbValue($rs->fields('update_key'));
		$p_villages->last_update_date->setDbValue($rs->fields('last_update_date'));
	}

	// Render row values based on field settings
	function RenderRow() {
		global $conn, $Security, $Language, $p_villages;

		// Initialize URLs
		$this->ExportPrintUrl = $this->PageUrl() . "export=print&" . "id=" . urlencode($p_villages->id->CurrentValue);
		$this->ExportHtmlUrl = $this->PageUrl() . "export=html&" . "id=" . urlencode($p_villages->id->CurrentValue);
		$this->ExportExcelUrl = $this->PageUrl() . "export=excel&" . "id=" . urlencode($p_villages->id->CurrentValue);
		$this->ExportWordUrl = $this->PageUrl() . "export=word&" . "id=" . urlencode($p_villages->id->CurrentValue);
		$this->ExportXmlUrl = $this->PageUrl() . "export=xml&" . "id=" . urlencode($p_villages->id->CurrentValue);
		$this->ExportCsvUrl = $this->PageUrl() . "export=csv&" . "id=" . urlencode($p_villages->id->CurrentValue);
		$this->AddUrl = $p_villages->AddUrl();
		$this->EditUrl = $p_villages->EditUrl();
		$this->CopyUrl = $p_villages->CopyUrl();
		$this->DeleteUrl = $p_villages->DeleteUrl();
		$this->ListUrl = $p_villages->ListUrl();

		// Call Row_Rendering event
		$p_villages->Row_Rendering();

		// Common render codes for all row types
		// id

		$p_villages->id->CellCssStyle = ""; $p_villages->id->CellCssClass = "";
		$p_villages->id->CellAttrs = array(); $p_villages->id->ViewAttrs = array(); $p_villages->id->EditAttrs = array();

		// player_name
		$p_villages->player_name->CellCssStyle = ""; $p_villages->player_name->CellCssClass = "";
		$p_villages->player_name->CellAttrs = array(); $p_villages->player_name->ViewAttrs = array(); $p_villages->player_name->EditAttrs = array();

		// village_name
		$p_villages->village_name->CellCssStyle = ""; $p_villages->village_name->CellCssClass = "";
		$p_villages->village_name->CellAttrs = array(); $p_villages->village_name->ViewAttrs = array(); $p_villages->village_name->EditAttrs = array();

		// is_capital
		$p_villages->is_capital->CellCssStyle = ""; $p_villages->is_capital->CellCssClass = "";
		$p_villages->is_capital->CellAttrs = array(); $p_villages->is_capital->ViewAttrs = array(); $p_villages->is_capital->EditAttrs = array();

		// is_special_village
		$p_villages->is_special_village->CellCssStyle = ""; $p_villages->is_special_village->CellCssClass = "";
		$p_villages->is_special_village->CellAttrs = array(); $p_villages->is_special_village->ViewAttrs = array(); $p_villages->is_special_village->EditAttrs = array();

		// people_count
		$p_villages->people_count->CellCssStyle = ""; $p_villages->people_count->CellCssClass = "";
		$p_villages->people_count->CellAttrs = array(); $p_villages->people_count->ViewAttrs = array(); $p_villages->people_count->EditAttrs = array();

		// crop_consumption
		$p_villages->crop_consumption->CellCssStyle = ""; $p_villages->crop_consumption->CellCssClass = "";
		$p_villages->crop_consumption->CellAttrs = array(); $p_villages->crop_consumption->ViewAttrs = array(); $p_villages->crop_consumption->EditAttrs = array();

		// resources
		$p_villages->resources->CellCssStyle = ""; $p_villages->resources->CellCssClass = "";
		$p_villages->resources->CellAttrs = array(); $p_villages->resources->ViewAttrs = array(); $p_villages->resources->EditAttrs = array();

		// cp
		$p_villages->cp->CellCssStyle = ""; $p_villages->cp->CellCssClass = "";
		$p_villages->cp->CellAttrs = array(); $p_villages->cp->ViewAttrs = array(); $p_villages->cp->EditAttrs = array();

		// buildings
		$p_villages->buildings->CellCssStyle = ""; $p_villages->buildings->CellCssClass = "";
		$p_villages->buildings->CellAttrs = array(); $p_villages->buildings->ViewAttrs = array(); $p_villages->buildings->EditAttrs = array();

		// troops_num
		$p_villages->troops_num->CellCssStyle = ""; $p_villages->troops_num->CellCssClass = "";
		$p_villages->troops_num->CellAttrs = array(); $p_villages->troops_num->ViewAttrs = array(); $p_villages->troops_num->EditAttrs = array();
		if ($p_villages->RowType == EW_ROWTYPE_VIEW) { // View row

			// id
			$p_villages->id->ViewValue = $p_villages->id->CurrentValue;
			$p_villages->id->CssStyle = "";
			$p_villages->id->CssClass = "";
			$p_villages->id->ViewCustomAttributes = "";

			// player_name
			$p_villages->player_name->ViewValue = $p_villages->player_name->CurrentValue;
			$p_villages->player_name->CssStyle = "";
			$p_villages->player_name->CssClass = "";
			$p_villages->player_name->ViewCustomAttributes = "";

			// village_name
			$p_villages->village_name->ViewValue = $p_villages->village_name->CurrentValue;
			$p_villages->village_name->CssStyle = "";
			$p_villages->village_name->CssClass = "";
			$p_villages->village_name->ViewCustomAttributes = "";

			// is_capital
			$p_villages->is_capital->ViewValue = $p_villages->is_capital->CurrentValue;
			$p_villages->is_capital->CssStyle = "";
			$p_villages->is_capital->CssClass = "";
			$p_villages->is_capital->ViewCustomAttributes = "";

			// is_special_village
			$p_villages->is_special_village->ViewValue = $p_villages->is_special_village->CurrentValue;
			$p_villages->is_special_village->CssStyle = "";
			$p_villages->is_special_village->CssClass = "";
			$p_villages->is_special_village->ViewCustomAttributes = "";

			// people_count
			$p_villages->people_count->ViewValue = $p_villages->people_count->CurrentValue;
			$p_villages->people_count->CssStyle = "";
			$p_villages->people_count->CssClass = "";
			$p_villages->people_count->ViewCustomAttributes = "";

			// crop_consumption
			$p_villages->crop_consumption->ViewValue = $p_villages->crop_consumption->CurrentValue;
			$p_villages->crop_consumption->CssStyle = "";
			$p_villages->crop_consumption->CssClass = "";
			$p_villages->crop_consumption->ViewCustomAttributes = "";

			// resources
			$p_villages->resources->ViewValue = $p_villages->resources->CurrentValue;
			$p_villages->resources->CssStyle = "";
			$p_villages->resources->CssClass = "";
			$p_villages->resources->ViewCustomAttributes = "";

			// cp
			$p_villages->cp->ViewValue = $p_villages->cp->CurrentValue;
			$p_villages->cp->CssStyle = "";
			$p_villages->cp->CssClass = "";
			$p_villages->cp->ViewCustomAttributes = "";

			// buildings
			$p_villages->buildings->ViewValue = $p_villages->buildings->CurrentValue;
			$p_villages->buildings->CssStyle = "";
			$p_villages->buildings->CssClass = "";
			$p_villages->buildings->ViewCustomAttributes = "";

			// troops_num
			$p_villages->troops_num->ViewValue = $p_villages->troops_num->CurrentValue;
			$p_villages->troops_num->CssStyle = "";
			$p_villages->troops_num->CssClass = "";
			$p_villages->troops_num->ViewCustomAttributes = "";

			// id
			$p_villages->id->HrefValue = "";
			$p_villages->id->TooltipValue = "";

			// player_name
			$p_villages->player_name->HrefValue = "";
			$p_villages->player_name->TooltipValue = "";

			// village_name
			$p_villages->village_name->HrefValue = "";
			$p_villages->village_name->TooltipValue = "";

			// is_capital
			$p_villages->is_capital->HrefValue = "";
			$p_villages->is_capital->TooltipValue = "";

			// is_special_village
			$p_villages->is_special_village->HrefValue = "";
			$p_villages->is_special_village->TooltipValue = "";

			// people_count
			$p_villages->people_count->HrefValue = "";
			$p_villages->people_count->TooltipValue = "";

			// crop_consumption
			$p_villages->crop_consumption->HrefValue = "";
			$p_villages->crop_consumption->TooltipValue = "";

			// resources
			$p_villages->resources->HrefValue = "";
			$p_villages->resources->TooltipValue = "";

			// cp
			$p_villages->cp->HrefValue = "";
			$p_villages->cp->TooltipValue = "";

			// buildings
			$p_villages->buildings->HrefValue = "";
			$p_villages->buildings->TooltipValue = "";

			// troops_num
			$p_villages->troops_num->HrefValue = "";
			$p_villages->troops_num->TooltipValue = "";
		}

		// Call Row Rendered event
		if ($p_villages->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$p_villages->Row_Rendered();
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	function Message_Showing(&$msg) {

		// Example:
		//$msg = "your new message";

	}
}
?>
