<?php
session_start(); // Initialize Session data
ob_start(); // Turn on output buffering
?>
<?php include "ewcfg7.php" ?>
<?php include "ewmysql7.php" ?>
<?php include "phpfn7.php" ?>
<?php include "p_playersinfo.php" ?>
<?php include "userfn7.php" ?>
<?php

// Create page object
$p_players_list = new cp_players_list();
$Page =& $p_players_list;

// Page init
$p_players_list->Page_Init();

// Page main
$p_players_list->Page_Main();
?>
<?php include "header.php" ?>
<?php if ($p_players->Export == "") { ?>
<script type="text/javascript">
<!--

// Create page object
var p_players_list = new ew_Page("p_players_list");

// page properties
p_players_list.PageID = "list"; // page ID
p_players_list.FormID = "fp_playerslist"; // form ID
var EW_PAGE_ID = p_players_list.PageID; // for backward compatibility

// extend page with validate function for search
p_players_list.ValidateSearch = function(fobj) {
	ew_PostAutoSuggest(fobj);
	if (this.ValidateRequired) {
		var infix = "";
		elm = fobj.elements["x" + infix + "_id"];
		if (elm && !ew_CheckInteger(elm.value))
			return ew_OnError(this, elm, "<?php echo ew_JsEncode2($p_players->id->FldErrMsg()) ?>");

		// Call Form Custom Validate event
		if (!this.Form_CustomValidate(fobj))
			return false;
	}
	for (var i=0; i<fobj.elements.length; i++) {
		var elem = fobj.elements[i];
		if (elem.name.substring(0,2) == "s_" || elem.name.substring(0,3) == "sv_")
			elem.value = "";
	}
	return true;
}

// extend page with Form_CustomValidate function
p_players_list.Form_CustomValidate =  
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }
<?php if (EW_CLIENT_VALIDATE) { ?>
p_players_list.ValidateRequired = true; // uses JavaScript validation
<?php } else { ?>
p_players_list.ValidateRequired = false; // no JavaScript validation
<?php } ?>

//-->
</script>
<script type="text/javascript">
<!--
var ew_DHTMLEditors = [];

//-->
</script>
<script language="JavaScript" type="text/javascript">
<!--

// Write your client script here, no need to add script tags.
// To include another .js script, use:
// ew_ClientScriptInclude("my_javascript.js"); 
//-->

</script>
<?php } ?>
<?php if ($p_players->Export == "") { ?>
<?php } ?>
<?php
	$bSelectLimit = EW_SELECT_LIMIT;
	if ($bSelectLimit) {
		$p_players_list->lTotalRecs = $p_players->SelectRecordCount();
	} else {
		if ($rs = $p_players_list->LoadRecordset())
			$p_players_list->lTotalRecs = $rs->RecordCount();
	}
	$p_players_list->lStartRec = 1;
	if ($p_players_list->lDisplayRecs <= 0 || ($p_players->Export <> "" && $p_players->ExportAll)) // Display all records
		$p_players_list->lDisplayRecs = $p_players_list->lTotalRecs;
	if (!($p_players->Export <> "" && $p_players->ExportAll))
		$p_players_list->SetUpStartRec(); // Set up start record position
	if ($bSelectLimit)
		$rs = $p_players_list->LoadRecordset($p_players_list->lStartRec-1, $p_players_list->lDisplayRecs);
?>
<p><span class="phpmaker" style="white-space: nowrap;"><?php echo $Language->Phrase("TblTypeTABLE") ?><?php echo $p_players->TableCaption() ?>
</span></p>
<?php if ($Security->IsLoggedIn()) { ?>
<?php if ($p_players->Export == "" && $p_players->CurrentAction == "") { ?>
<a href="javascript:ew_ToggleSearchPanel(p_players_list);" style="text-decoration: none;"><img id="p_players_list_SearchImage" src="images/collapse.gif" alt="" width="9" height="9" border="0"></a><span class="phpmaker">&nbsp;<?php echo $Language->Phrase("Search") ?></span><br>
<div id="p_players_list_SearchPanel">
<form name="fp_playerslistsrch" id="fp_playerslistsrch" class="ewForm" action="<?php echo ew_CurrentPage() ?>" onsubmit="return p_players_list.ValidateSearch(this);">
<input type="hidden" id="t" name="t" value="p_players">
<?php
if ($gsSearchError == "")
	$p_players_list->LoadAdvancedSearch(); // Load advanced search

// Render for search
$p_players->RowType = EW_ROWTYPE_SEARCH;

// Render row
$p_players_list->RenderRow();
?>
<table class="ewBasicSearch">
	<tr>
		<td><span class="phpmaker"><?php echo $p_players->id->FldCaption() ?></span></td>
		<td><span class="ewSearchOpr"><?php echo $Language->Phrase("=") ?><input type="hidden" name="z_id" id="z_id" value="="></span></td>
		<td>			
			<div style="white-space: nowrap;">
				<span class="phpmaker" style="float: left;">
<input type="text" name="x_id" id="x_id" title="<?php echo $p_players->id->FldTitle() ?>" value="<?php echo $p_players->id->EditValue ?>"<?php echo $p_players->id->EditAttributes() ?>>
</span>
			</div>
		</td>
	</tr>
	<tr>
		<td><span class="phpmaker"><?php echo $p_players->name->FldCaption() ?></span></td>
		<td><span class="ewSearchOpr"><?php echo $Language->Phrase("LIKE") ?><input type="hidden" name="z_name" id="z_name" value="LIKE"></span></td>
		<td>			
			<div style="white-space: nowrap;">
				<span class="phpmaker" style="float: left;">
<input type="text" name="x_name" id="x_name" title="<?php echo $p_players->name->FldTitle() ?>" size="30" maxlength="255" value="<?php echo $p_players->name->EditValue ?>"<?php echo $p_players->name->EditAttributes() ?>>
</span>
			</div>
		</td>
	</tr>
</table>
<table class="ewBasicSearch">
	<tr>
		<td><span class="phpmaker">
			<input type="text" name="<?php echo EW_TABLE_BASIC_SEARCH ?>" id="<?php echo EW_TABLE_BASIC_SEARCH ?>" size="20" value="<?php echo ew_HtmlEncode($p_players->getSessionBasicSearchKeyword()) ?>">
			<input type="Submit" name="Submit" id="Submit" value="<?php echo ew_BtnCaption($Language->Phrase("QuickSearchBtn")) ?>">&nbsp;
			<a href="<?php echo $p_players_list->PageUrl() ?>cmd=reset"><?php echo $Language->Phrase("ShowAll") ?></a>&nbsp;
		</span></td>
	</tr>
	<tr>
	<td><span class="phpmaker"><label><input type="radio" name="<?php echo EW_TABLE_BASIC_SEARCH_TYPE ?>" id="<?php echo EW_TABLE_BASIC_SEARCH_TYPE ?>" value=""<?php if ($p_players->getSessionBasicSearchType() == "") { ?> checked="checked"<?php } ?>><?php echo $Language->Phrase("ExactPhrase") ?></label>&nbsp;&nbsp;<label><input type="radio" name="<?php echo EW_TABLE_BASIC_SEARCH_TYPE ?>" id="<?php echo EW_TABLE_BASIC_SEARCH_TYPE ?>" value="AND"<?php if ($p_players->getSessionBasicSearchType() == "AND") { ?> checked="checked"<?php } ?>><?php echo $Language->Phrase("AllWord") ?></label>&nbsp;&nbsp;<label><input type="radio" name="<?php echo EW_TABLE_BASIC_SEARCH_TYPE ?>" id="<?php echo EW_TABLE_BASIC_SEARCH_TYPE ?>" value="OR"<?php if ($p_players->getSessionBasicSearchType() == "OR") { ?> checked="checked"<?php } ?>><?php echo $Language->Phrase("AnyWord") ?></label></span></td>
	</tr>
</table>
</form>
</div>
<?php } ?>
<?php } ?>
<?php
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
$p_players_list->ShowMessage();
?>
<br>
<table cellspacing="0" class="ewGrid"><tr><td class="ewGridContent">
<form name="fp_playerslist" id="fp_playerslist" class="ewForm" action="" method="post">
<div id="gmp_p_players" class="ewGridMiddlePanel">
<?php if ($p_players_list->lTotalRecs > 0) { ?>
<table cellspacing="0" rowhighlightclass="ewTableHighlightRow" rowselectclass="ewTableSelectRow" roweditclass="ewTableEditRow" class="ewTable ewTableSeparate">
<?php echo $p_players->TableCustomInnerHtml ?>
<thead><!-- Table header -->
	<tr class="ewTableHeader">
<?php

// Render list options
$p_players_list->RenderListOptions();

// Render list options (header, left)
$p_players_list->ListOptions->Render("header", "left");
?>
<?php if ($p_players->id->Visible) { // id ?>
	<?php if ($p_players->SortUrl($p_players->id) == "") { ?>
		<td><?php echo $p_players->id->FldCaption() ?></td>
	<?php } else { ?>
		<td><div class="ewPointer" onmousedown="ew_Sort(event,'<?php echo $p_players->SortUrl($p_players->id) ?>',1);">
			<table cellspacing="0" class="ewTableHeaderBtn"><thead><tr><td><?php echo $p_players->id->FldCaption() ?></td><td style="width: 10px;"><?php if ($p_players->id->getSort() == "ASC") { ?><img src="images/sortup.gif" width="10" height="9" border="0"><?php } elseif ($p_players->id->getSort() == "DESC") { ?><img src="images/sortdown.gif" width="10" height="9" border="0"><?php } ?></td></tr></thead></table>
		</div></td>		
	<?php } ?>
<?php } ?>		
<?php if ($p_players->name->Visible) { // name ?>
	<?php if ($p_players->SortUrl($p_players->name) == "") { ?>
		<td><?php echo $p_players->name->FldCaption() ?></td>
	<?php } else { ?>
		<td><div class="ewPointer" onmousedown="ew_Sort(event,'<?php echo $p_players->SortUrl($p_players->name) ?>',1);">
			<table cellspacing="0" class="ewTableHeaderBtn"><thead><tr><td><?php echo $p_players->name->FldCaption() ?><?php echo $Language->Phrase("SrchLegend") ?></td><td style="width: 10px;"><?php if ($p_players->name->getSort() == "ASC") { ?><img src="images/sortup.gif" width="10" height="9" border="0"><?php } elseif ($p_players->name->getSort() == "DESC") { ?><img src="images/sortdown.gif" width="10" height="9" border="0"><?php } ?></td></tr></thead></table>
		</div></td>		
	<?php } ?>
<?php } ?>		
<?php if ($p_players->zemail->Visible) { // email ?>
	<?php if ($p_players->SortUrl($p_players->zemail) == "") { ?>
		<td><?php echo $p_players->zemail->FldCaption() ?></td>
	<?php } else { ?>
		<td><div class="ewPointer" onmousedown="ew_Sort(event,'<?php echo $p_players->SortUrl($p_players->zemail) ?>',1);">
			<table cellspacing="0" class="ewTableHeaderBtn"><thead><tr><td><?php echo $p_players->zemail->FldCaption() ?><?php echo $Language->Phrase("SrchLegend") ?></td><td style="width: 10px;"><?php if ($p_players->zemail->getSort() == "ASC") { ?><img src="images/sortup.gif" width="10" height="9" border="0"><?php } elseif ($p_players->zemail->getSort() == "DESC") { ?><img src="images/sortdown.gif" width="10" height="9" border="0"><?php } ?></td></tr></thead></table>
		</div></td>		
	<?php } ?>
<?php } ?>		
<?php if ($p_players->is_active->Visible) { // is_active ?>
	<?php if ($p_players->SortUrl($p_players->is_active) == "") { ?>
		<td><?php echo $p_players->is_active->FldCaption() ?></td>
	<?php } else { ?>
		<td><div class="ewPointer" onmousedown="ew_Sort(event,'<?php echo $p_players->SortUrl($p_players->is_active) ?>',1);">
			<table cellspacing="0" class="ewTableHeaderBtn"><thead><tr><td><?php echo $p_players->is_active->FldCaption() ?></td><td style="width: 10px;"><?php if ($p_players->is_active->getSort() == "ASC") { ?><img src="images/sortup.gif" width="10" height="9" border="0"><?php } elseif ($p_players->is_active->getSort() == "DESC") { ?><img src="images/sortdown.gif" width="10" height="9" border="0"><?php } ?></td></tr></thead></table>
		</div></td>		
	<?php } ?>
<?php } ?>		
<?php if ($p_players->active_plus_account->Visible) { // active_plus_account ?>
	<?php if ($p_players->SortUrl($p_players->active_plus_account) == "") { ?>
		<td><?php echo $p_players->active_plus_account->FldCaption() ?></td>
	<?php } else { ?>
		<td><div class="ewPointer" onmousedown="ew_Sort(event,'<?php echo $p_players->SortUrl($p_players->active_plus_account) ?>',1);">
			<table cellspacing="0" class="ewTableHeaderBtn"><thead><tr><td><?php echo $p_players->active_plus_account->FldCaption() ?><?php echo $Language->Phrase("SrchLegend") ?></td><td style="width: 10px;"><?php if ($p_players->active_plus_account->getSort() == "ASC") { ?><img src="images/sortup.gif" width="10" height="9" border="0"><?php } elseif ($p_players->active_plus_account->getSort() == "DESC") { ?><img src="images/sortdown.gif" width="10" height="9" border="0"><?php } ?></td></tr></thead></table>
		</div></td>		
	<?php } ?>
<?php } ?>		
<?php if ($p_players->last_ip->Visible) { // last_ip ?>
	<?php if ($p_players->SortUrl($p_players->last_ip) == "") { ?>
		<td><?php echo $p_players->last_ip->FldCaption() ?></td>
	<?php } else { ?>
		<td><div class="ewPointer" onmousedown="ew_Sort(event,'<?php echo $p_players->SortUrl($p_players->last_ip) ?>',1);">
			<table cellspacing="0" class="ewTableHeaderBtn"><thead><tr><td><?php echo $p_players->last_ip->FldCaption() ?><?php echo $Language->Phrase("SrchLegend") ?></td><td style="width: 10px;"><?php if ($p_players->last_ip->getSort() == "ASC") { ?><img src="images/sortup.gif" width="10" height="9" border="0"><?php } elseif ($p_players->last_ip->getSort() == "DESC") { ?><img src="images/sortdown.gif" width="10" height="9" border="0"><?php } ?></td></tr></thead></table>
		</div></td>		
	<?php } ?>
<?php } ?>		
<?php if ($p_players->gold_num->Visible) { // gold_num ?>
	<?php if ($p_players->SortUrl($p_players->gold_num) == "") { ?>
		<td><?php echo $p_players->gold_num->FldCaption() ?></td>
	<?php } else { ?>
		<td><div class="ewPointer" onmousedown="ew_Sort(event,'<?php echo $p_players->SortUrl($p_players->gold_num) ?>',1);">
			<table cellspacing="0" class="ewTableHeaderBtn"><thead><tr><td><?php echo $p_players->gold_num->FldCaption() ?></td><td style="width: 10px;"><?php if ($p_players->gold_num->getSort() == "ASC") { ?><img src="images/sortup.gif" width="10" height="9" border="0"><?php } elseif ($p_players->gold_num->getSort() == "DESC") { ?><img src="images/sortdown.gif" width="10" height="9" border="0"><?php } ?></td></tr></thead></table>
		</div></td>		
	<?php } ?>
<?php } ?>		
<?php if ($p_players->total_people_count->Visible) { // total_people_count ?>
	<?php if ($p_players->SortUrl($p_players->total_people_count) == "") { ?>
		<td><?php echo $p_players->total_people_count->FldCaption() ?></td>
	<?php } else { ?>
		<td><div class="ewPointer" onmousedown="ew_Sort(event,'<?php echo $p_players->SortUrl($p_players->total_people_count) ?>',1);">
			<table cellspacing="0" class="ewTableHeaderBtn"><thead><tr><td><?php echo $p_players->total_people_count->FldCaption() ?><?php echo $Language->Phrase("SrchLegend") ?></td><td style="width: 10px;"><?php if ($p_players->total_people_count->getSort() == "ASC") { ?><img src="images/sortup.gif" width="10" height="9" border="0"><?php } elseif ($p_players->total_people_count->getSort() == "DESC") { ?><img src="images/sortdown.gif" width="10" height="9" border="0"><?php } ?></td></tr></thead></table>
		</div></td>		
	<?php } ?>
<?php } ?>		
<?php

// Render list options (header, right)
$p_players_list->ListOptions->Render("header", "right");
?>
	</tr>
</thead>
<?php
if ($p_players->ExportAll && $p_players->Export <> "") {
	$p_players_list->lStopRec = $p_players_list->lTotalRecs;
} else {
	$p_players_list->lStopRec = $p_players_list->lStartRec + $p_players_list->lDisplayRecs - 1; // Set the last record to display
}
$p_players_list->lRecCount = $p_players_list->lStartRec - 1;
if ($rs && !$rs->EOF) {
	$rs->MoveFirst();
	if (!$bSelectLimit && $p_players_list->lStartRec > 1)
		$rs->Move($p_players_list->lStartRec - 1);
}

// Initialize aggregate
$p_players->RowType = EW_ROWTYPE_AGGREGATEINIT;
$p_players_list->RenderRow();
$p_players_list->lRowCnt = 0;
while (($p_players->CurrentAction == "gridadd" || !$rs->EOF) &&
	$p_players_list->lRecCount < $p_players_list->lStopRec) {
	$p_players_list->lRecCount++;
	if (intval($p_players_list->lRecCount) >= intval($p_players_list->lStartRec)) {
		$p_players_list->lRowCnt++;

	// Init row class and style
	$p_players->CssClass = "";
	$p_players->CssStyle = "";
	$p_players->RowAttrs = array('onmouseover'=>'ew_MouseOver(event, this);', 'onmouseout'=>'ew_MouseOut(event, this);', 'onclick'=>'ew_Click(event, this);');
	if ($p_players->CurrentAction == "gridadd") {
		$p_players_list->LoadDefaultValues(); // Load default values
	} else {
		$p_players_list->LoadRowValues($rs); // Load row values
	}
	$p_players->RowType = EW_ROWTYPE_VIEW; // Render view

	// Render row
	$p_players_list->RenderRow();

	// Render list options
	$p_players_list->RenderListOptions();
?>
	<tr<?php echo $p_players->RowAttributes() ?>>
<?php

// Render list options (body, left)
$p_players_list->ListOptions->Render("body", "left");
?>
	<?php if ($p_players->id->Visible) { // id ?>
		<td<?php echo $p_players->id->CellAttributes() ?>>
<div<?php echo $p_players->id->ViewAttributes() ?>><?php echo $p_players->id->ListViewValue() ?></div>
</td>
	<?php } ?>
	<?php if ($p_players->name->Visible) { // name ?>
		<td<?php echo $p_players->name->CellAttributes() ?>>
<div<?php echo $p_players->name->ViewAttributes() ?>><?php echo $p_players->name->ListViewValue() ?></div>
</td>
	<?php } ?>
	<?php if ($p_players->zemail->Visible) { // email ?>
		<td<?php echo $p_players->zemail->CellAttributes() ?>>
<div<?php echo $p_players->zemail->ViewAttributes() ?>><?php echo $p_players->zemail->ListViewValue() ?></div>
</td>
	<?php } ?>
	<?php if ($p_players->is_active->Visible) { // is_active ?>
		<td<?php echo $p_players->is_active->CellAttributes() ?>>
<div<?php echo $p_players->is_active->ViewAttributes() ?>><?php echo $p_players->is_active->ListViewValue() ?></div>
</td>
	<?php } ?>
	<?php if ($p_players->active_plus_account->Visible) { // active_plus_account ?>
		<td<?php echo $p_players->active_plus_account->CellAttributes() ?>>
<div<?php echo $p_players->active_plus_account->ViewAttributes() ?>><?php echo $p_players->active_plus_account->ListViewValue() ?></div>
</td>
	<?php } ?>
	<?php if ($p_players->last_ip->Visible) { // last_ip ?>
		<td<?php echo $p_players->last_ip->CellAttributes() ?>>
<div<?php echo $p_players->last_ip->ViewAttributes() ?>><?php echo $p_players->last_ip->ListViewValue() ?></div>
</td>
	<?php } ?>
	<?php if ($p_players->gold_num->Visible) { // gold_num ?>
		<td<?php echo $p_players->gold_num->CellAttributes() ?>>
<div<?php echo $p_players->gold_num->ViewAttributes() ?>><?php echo $p_players->gold_num->ListViewValue() ?></div>
</td>
	<?php } ?>
	<?php if ($p_players->total_people_count->Visible) { // total_people_count ?>
		<td<?php echo $p_players->total_people_count->CellAttributes() ?>>
<div<?php echo $p_players->total_people_count->ViewAttributes() ?>><?php echo $p_players->total_people_count->ListViewValue() ?></div>
</td>
	<?php } ?>
<?php

// Render list options (body, right)
$p_players_list->ListOptions->Render("body", "right");
?>
	</tr>
<?php
	}
	if ($p_players->CurrentAction <> "gridadd")
		$rs->MoveNext();
}
?>
</tbody>
</table>
<?php } ?>
</div>
</form>
<?php

// Close recordset
if ($rs)
	$rs->Close();
?>
<?php if ($p_players->Export == "") { ?>
<div class="ewGridLowerPanel">
<?php if ($p_players->CurrentAction <> "gridadd" && $p_players->CurrentAction <> "gridedit") { ?>
<form name="ewpagerform" id="ewpagerform" class="ewForm" action="<?php echo ew_CurrentPage() ?>">
<table border="0" cellspacing="0" cellpadding="0" class="ewPager">
	<tr>
		<td nowrap>
<?php if (!isset($p_players_list->Pager)) $p_players_list->Pager = new cPrevNextPager($p_players_list->lStartRec, $p_players_list->lDisplayRecs, $p_players_list->lTotalRecs) ?>
<?php if ($p_players_list->Pager->RecordCount > 0) { ?>
	<table border="0" cellspacing="0" cellpadding="0"><tr><td><span class="phpmaker"><?php echo $Language->Phrase("Page") ?>&nbsp;</span></td>
<!--first page button-->
	<?php if ($p_players_list->Pager->FirstButton->Enabled) { ?>
	<td><a href="<?php echo $p_players_list->PageUrl() ?>start=<?php echo $p_players_list->Pager->FirstButton->Start ?>"><img src="images/first.gif" alt="<?php echo $Language->Phrase("PagerFirst") ?>" width="16" height="16" border="0"></a></td>
	<?php } else { ?>
	<td><img src="images/firstdisab.gif" alt="<?php echo $Language->Phrase("PagerFirst") ?>" width="16" height="16" border="0"></td>
	<?php } ?>
<!--previous page button-->
	<?php if ($p_players_list->Pager->PrevButton->Enabled) { ?>
	<td><a href="<?php echo $p_players_list->PageUrl() ?>start=<?php echo $p_players_list->Pager->PrevButton->Start ?>"><img src="images/prev.gif" alt="<?php echo $Language->Phrase("PagerPrevious") ?>" width="16" height="16" border="0"></a></td>
	<?php } else { ?>
	<td><img src="images/prevdisab.gif" alt="<?php echo $Language->Phrase("PagerPrevious") ?>" width="16" height="16" border="0"></td>
	<?php } ?>
<!--current page number-->
	<td><input type="text" name="<?php echo EW_TABLE_PAGE_NO ?>" id="<?php echo EW_TABLE_PAGE_NO ?>" value="<?php echo $p_players_list->Pager->CurrentPage ?>" size="4"></td>
<!--next page button-->
	<?php if ($p_players_list->Pager->NextButton->Enabled) { ?>
	<td><a href="<?php echo $p_players_list->PageUrl() ?>start=<?php echo $p_players_list->Pager->NextButton->Start ?>"><img src="images/next.gif" alt="<?php echo $Language->Phrase("PagerNext") ?>" width="16" height="16" border="0"></a></td>	
	<?php } else { ?>
	<td><img src="images/nextdisab.gif" alt="<?php echo $Language->Phrase("PagerNext") ?>" width="16" height="16" border="0"></td>
	<?php } ?>
<!--last page button-->
	<?php if ($p_players_list->Pager->LastButton->Enabled) { ?>
	<td><a href="<?php echo $p_players_list->PageUrl() ?>start=<?php echo $p_players_list->Pager->LastButton->Start ?>"><img src="images/last.gif" alt="<?php echo $Language->Phrase("PagerLast") ?>" width="16" height="16" border="0"></a></td>	
	<?php } else { ?>
	<td><img src="images/lastdisab.gif" alt="<?php echo $Language->Phrase("PagerLast") ?>" width="16" height="16" border="0"></td>
	<?php } ?>
	<td><span class="phpmaker">&nbsp;<?php echo $Language->Phrase("of") ?>&nbsp;<?php echo $p_players_list->Pager->PageCount ?></span></td>
	</tr></table>
	</td>	
	<td>&nbsp;&nbsp;&nbsp;&nbsp;</td>
	<td>
	<span class="phpmaker"><?php echo $Language->Phrase("Record") ?>&nbsp;<?php echo $p_players_list->Pager->FromIndex ?>&nbsp;<?php echo $Language->Phrase("To") ?>&nbsp;<?php echo $p_players_list->Pager->ToIndex ?>&nbsp;<?php echo $Language->Phrase("Of") ?>&nbsp;<?php echo $p_players_list->Pager->RecordCount ?></span>
<?php } else { ?>
	<?php if ($p_players_list->sSrchWhere == "0=101") { ?>
	<span class="phpmaker"><?php echo $Language->Phrase("EnterSearchCriteria") ?></span>
	<?php } else { ?>
	<span class="phpmaker"><?php echo $Language->Phrase("NoRecord") ?></span>
	<?php } ?>
<?php } ?>
		</td>
<?php if ($p_players_list->lTotalRecs > 0) { ?>
		<td>&nbsp;&nbsp;&nbsp;&nbsp;</td>
		<td><table border="0" cellspacing="0" cellpadding="0"><tr><td><?php echo $Language->Phrase("RecordsPerPage") ?>&nbsp;</td><td>
<input type="hidden" id="t" name="t" value="p_players">
<select name="<?php echo EW_TABLE_REC_PER_PAGE ?>" id="<?php echo EW_TABLE_REC_PER_PAGE ?>" onchange="this.form.submit();" class="phpmaker">
<option value="10"<?php if ($p_players_list->lDisplayRecs == 10) { ?> selected="selected"<?php } ?>>10</option>
<option value="50"<?php if ($p_players_list->lDisplayRecs == 50) { ?> selected="selected"<?php } ?>>50</option>
<option value="190"<?php if ($p_players_list->lDisplayRecs == 190) { ?> selected="selected"<?php } ?>>190</option>
<option value="220"<?php if ($p_players_list->lDisplayRecs == 220) { ?> selected="selected"<?php } ?>>220</option>
<option value="480"<?php if ($p_players_list->lDisplayRecs == 480) { ?> selected="selected"<?php } ?>>480</option>
<option value="500"<?php if ($p_players_list->lDisplayRecs == 500) { ?> selected="selected"<?php } ?>>500</option>
</select></td></tr></table>
		</td>
<?php } ?>
	</tr>
</table>
</form>
<?php } ?>
<?php //if ($p_players_list->lTotalRecs > 0) { ?>
<span class="phpmaker">
</span>
<?php //} ?>
</div>
<?php } ?>
</td></tr></table>
<?php if ($p_players->Export == "" && $p_players->CurrentAction == "") { ?>
<?php } ?>
<?php if ($p_players->Export == "") { ?>
<script language="JavaScript" type="text/javascript">
<!--

// Write your table-specific startup script here
// document.write("page loaded");
//-->

</script>
<?php } ?>
<?php include "footer.php" ?>
<?php
$p_players_list->Page_Terminate();
?>
<?php

//
// Page class
//
class cp_players_list {

	// Page ID
	var $PageID = 'list';

	// Table name
	var $TableName = 'p_players';

	// Page object name
	var $PageObjName = 'p_players_list';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		global $p_players;
		if ($p_players->UseTokenInUrl) $PageUrl .= "t=" . $p_players->TableVar . "&"; // Add page token
		return $PageUrl;
	}

	// Page URLs
	var $AddUrl;
	var $EditUrl;
	var $CopyUrl;
	var $DeleteUrl;
	var $ViewUrl;
	var $ListUrl;

	// Export URLs
	var $ExportPrintUrl;
	var $ExportHtmlUrl;
	var $ExportExcelUrl;
	var $ExportWordUrl;
	var $ExportXmlUrl;
	var $ExportCsvUrl;

	// Update URLs
	var $InlineAddUrl;
	var $InlineCopyUrl;
	var $InlineEditUrl;
	var $GridAddUrl;
	var $GridEditUrl;
	var $MultiDeleteUrl;
	var $MultiUpdateUrl;

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		if (@$_SESSION[EW_SESSION_MESSAGE] <> "") { // Append
			$_SESSION[EW_SESSION_MESSAGE] .= "<br>" . $v;
		} else {
			$_SESSION[EW_SESSION_MESSAGE] = $v;
		}
	}

	// Show message
	function ShowMessage() {
		$sMessage = $this->getMessage();
		$this->Message_Showing($sMessage);
		if ($sMessage <> "") { // Message in Session, display
			echo "<p><span class=\"ewMessage\">" . $sMessage . "</span></p>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm, $p_players;
		if ($p_players->UseTokenInUrl) {
			if ($objForm)
				return ($p_players->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($p_players->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}

	//
	// Page class constructor
	//
	function cp_players_list() {
		global $conn, $Language;

		// Language object
		$Language = new cLanguage();

		// Table object (p_players)
		$GLOBALS["p_players"] = new cp_players();

		// Initialize URLs
		$this->ExportPrintUrl = $this->PageUrl() . "export=print";
		$this->ExportExcelUrl = $this->PageUrl() . "export=excel";
		$this->ExportWordUrl = $this->PageUrl() . "export=word";
		$this->ExportHtmlUrl = $this->PageUrl() . "export=html";
		$this->ExportXmlUrl = $this->PageUrl() . "export=xml";
		$this->ExportCsvUrl = $this->PageUrl() . "export=csv";
		$this->AddUrl = $GLOBALS["p_players"]->AddUrl();
		$this->InlineAddUrl = $this->PageUrl() . "a=add";
		$this->GridAddUrl = $this->PageUrl() . "a=gridadd";
		$this->GridEditUrl = $this->PageUrl() . "a=gridedit";
		$this->MultiDeleteUrl = "p_playersdelete.php";
		$this->MultiUpdateUrl = "p_playersupdate.php";

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'list', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'p_players', TRUE);

		// Start timer
		$GLOBALS["gsTimer"] = new cTimer();

		// Open connection
		$conn = ew_Connect();

		// List options
		$this->ListOptions = new cListOptions();
	}

	// 
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;
		global $p_players;

		// Security
		$Security = new cAdvancedSecurity();
		if (!$Security->IsLoggedIn()) $Security->AutoLogin();
		if (!$Security->IsLoggedIn()) {
			$Security->SaveLastUrl();
			$this->Page_Terminate("login.php");
		}

		// Get export parameters
		if (@$_GET["export"] <> "") {
			$p_players->Export = $_GET["export"];
		} elseif (ew_IsHttpPost()) {
			if (@$_POST["exporttype"] <> "")
				$p_players->Export = $_POST["exporttype"];
		} else {
			$p_players->setExportReturnUrl(ew_CurrentUrl());
		}
		$gsExport = $p_players->Export; // Get export parameter, used in header
		$gsExportFile = $p_players->TableVar; // Get export file, used in header

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $conn;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		 // Close connection
		$conn->Close();

		// Go to URL if specified
		$this->Page_Redirecting($url);
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();
			header("Location: " . $url);
		}
		exit();
	}

	// Class variables
	var $ListOptions; // List options
	var $lDisplayRecs = 500;
	var $lStartRec;
	var $lStopRec;
	var $lTotalRecs = 0;
	var $lRecRange = 10;
	var $sSrchWhere = ""; // Search WHERE clause
	var $lRecCnt = 0; // Record count
	var $lEditRowCnt;
	var $lRowCnt;
	var $lRowIndex; // Row index
	var $lRecPerRow = 0;
	var $lColCnt = 0;
	var $sDbMasterFilter = ""; // Master filter
	var $sDbDetailFilter = ""; // Detail filter
	var $bMasterRecordExists;	
	var $sMultiSelectKey;
	var $RestoreSearch;

	//
	// Page main
	//
	function Page_Main() {
		global $objForm, $Language, $gsSearchError, $Security, $p_players;

		// Search filters
		$sSrchAdvanced = ""; // Advanced search filter
		$sSrchBasic = ""; // Basic search filter
		$sFilter = "";
		if ($this->IsPageRequest()) { // Validate request

			// Set up records per page
			$this->SetUpDisplayRecs();

			// Handle reset command
			$this->ResetCmd();

			// Set up list options
			$this->SetupListOptions();

			// Get basic search values
			$this->LoadBasicSearchValues();

			// Get and validate search values for advanced search
			$this->LoadSearchValues(); // Get search values
			if (!$this->ValidateSearch())
				$this->setMessage($gsSearchError);

			// Restore search parms from Session
			$this->RestoreSearchParms();

			// Call Recordset SearchValidated event
			$p_players->Recordset_SearchValidated();

			// Set up sorting order
			$this->SetUpSortOrder();

			// Get basic search criteria
			if ($gsSearchError == "")
				$sSrchBasic = $this->BasicSearchWhere();

			// Get search criteria for advanced search
			if ($gsSearchError == "")
				$sSrchAdvanced = $this->AdvancedSearchWhere();
		}

		// Restore display records
		if ($p_players->getRecordsPerPage() <> "") {
			$this->lDisplayRecs = $p_players->getRecordsPerPage(); // Restore from Session
		} else {
			$this->lDisplayRecs = 500; // Load default
		}

		// Load Sorting Order
		$this->LoadSortOrder();

		// Build search criteria
		if ($sSrchAdvanced <> "")
			$this->sSrchWhere = ($this->sSrchWhere <> "") ? "(" . $this->sSrchWhere . ") AND (" . $sSrchAdvanced . ")" : $sSrchAdvanced;
		if ($sSrchBasic <> "")
			$this->sSrchWhere = ($this->sSrchWhere <> "") ? "(" . $this->sSrchWhere . ") AND (" . $sSrchBasic. ")" : $sSrchBasic;

		// Call Recordset_Searching event
		$p_players->Recordset_Searching($this->sSrchWhere);

		// Save search criteria
		if ($this->sSrchWhere <> "") {
			if ($sSrchBasic == "")
				$this->ResetBasicSearchParms();
			if ($sSrchAdvanced == "")
				$this->ResetAdvancedSearchParms();
			$p_players->setSearchWhere($this->sSrchWhere); // Save to Session
			if (!$this->RestoreSearch) {
				$this->lStartRec = 1; // Reset start record counter
				$p_players->setStartRecordNumber($this->lStartRec);
			}
		} else {
			$this->sSrchWhere = $p_players->getSearchWhere();
		}

		// Build filter
		$sFilter = "";
		if ($this->sDbDetailFilter <> "")
			$sFilter = ($sFilter <> "") ? "(" . $sFilter . ") AND (" . $this->sDbDetailFilter . ")" : $this->sDbDetailFilter;
		if ($this->sSrchWhere <> "")
			$sFilter = ($sFilter <> "") ? "(" . $sFilter . ") AND (". $this->sSrchWhere . ")" : $this->sSrchWhere;

		// Set up filter in session
		$p_players->setSessionWhere($sFilter);
		$p_players->CurrentFilter = "";
	}

	// Set up number of records displayed per page
	function SetUpDisplayRecs() {
		global $p_players;
		$sWrk = @$_GET[EW_TABLE_REC_PER_PAGE];
		if ($sWrk <> "") {
			if (is_numeric($sWrk)) {
				$this->lDisplayRecs = intval($sWrk);
			} else {
				if (strtolower($sWrk) == "all") { // Display all records
					$this->lDisplayRecs = -1;
				} else {
					$this->lDisplayRecs = 500; // Non-numeric, load default
				}
			}
			$p_players->setRecordsPerPage($this->lDisplayRecs); // Save to Session

			// Reset start position
			$this->lStartRec = 1;
			$p_players->setStartRecordNumber($this->lStartRec);
		}
	}

	// Advanced search WHERE clause based on QueryString
	function AdvancedSearchWhere() {
		global $Security, $p_players;
		$sWhere = "";
		$this->BuildSearchSql($sWhere, $p_players->id, FALSE); // id
		$this->BuildSearchSql($sWhere, $p_players->name, FALSE); // name
		$this->BuildSearchSql($sWhere, $p_players->zemail, FALSE); // email
		$this->BuildSearchSql($sWhere, $p_players->is_active, FALSE); // is_active
		$this->BuildSearchSql($sWhere, $p_players->active_plus_account, FALSE); // active_plus_account
		$this->BuildSearchSql($sWhere, $p_players->activation_code, FALSE); // activation_code
		$this->BuildSearchSql($sWhere, $p_players->last_ip, FALSE); // last_ip
		$this->BuildSearchSql($sWhere, $p_players->description1, FALSE); // description1
		$this->BuildSearchSql($sWhere, $p_players->description2, FALSE); // description2
		$this->BuildSearchSql($sWhere, $p_players->house_name, FALSE); // house_name
		$this->BuildSearchSql($sWhere, $p_players->registration_date, FALSE); // registration_date
		$this->BuildSearchSql($sWhere, $p_players->gold_num, FALSE); // gold_num
		$this->BuildSearchSql($sWhere, $p_players->agent_for_players, FALSE); // agent_for_players
		$this->BuildSearchSql($sWhere, $p_players->my_agent_players, FALSE); // my_agent_players
		$this->BuildSearchSql($sWhere, $p_players->custom_links, FALSE); // custom_links
		$this->BuildSearchSql($sWhere, $p_players->medals, FALSE); // medals
		$this->BuildSearchSql($sWhere, $p_players->total_people_count, FALSE); // total_people_count
		$this->BuildSearchSql($sWhere, $p_players->selected_village_id, FALSE); // selected_village_id
		$this->BuildSearchSql($sWhere, $p_players->villages_count, FALSE); // villages_count
		$this->BuildSearchSql($sWhere, $p_players->villages_id, FALSE); // villages_id
		$this->BuildSearchSql($sWhere, $p_players->villages_data, FALSE); // villages_data
		$this->BuildSearchSql($sWhere, $p_players->friend_players, FALSE); // friend_players
		$this->BuildSearchSql($sWhere, $p_players->notes, FALSE); // notes
		$this->BuildSearchSql($sWhere, $p_players->hero_troop_id, FALSE); // hero_troop_id
		$this->BuildSearchSql($sWhere, $p_players->hero_level, FALSE); // hero_level
		$this->BuildSearchSql($sWhere, $p_players->hero_points, FALSE); // hero_points
		$this->BuildSearchSql($sWhere, $p_players->hero_name, FALSE); // hero_name
		$this->BuildSearchSql($sWhere, $p_players->attack_points, FALSE); // attack_points
		$this->BuildSearchSql($sWhere, $p_players->defense_points, FALSE); // defense_points
		$this->BuildSearchSql($sWhere, $p_players->week_attack_points, FALSE); // week_attack_points
		$this->BuildSearchSql($sWhere, $p_players->week_defense_points, FALSE); // week_defense_points
		$this->BuildSearchSql($sWhere, $p_players->week_dev_points, FALSE); // week_dev_points
		$this->BuildSearchSql($sWhere, $p_players->week_thief_points, FALSE); // week_thief_points

		// Set up search parm
		if ($sWhere <> "") {
			$this->SetSearchParm($p_players->id); // id
			$this->SetSearchParm($p_players->name); // name
			$this->SetSearchParm($p_players->zemail); // email
			$this->SetSearchParm($p_players->is_active); // is_active
			$this->SetSearchParm($p_players->active_plus_account); // active_plus_account
			$this->SetSearchParm($p_players->activation_code); // activation_code
			$this->SetSearchParm($p_players->last_ip); // last_ip
			$this->SetSearchParm($p_players->description1); // description1
			$this->SetSearchParm($p_players->description2); // description2
			$this->SetSearchParm($p_players->house_name); // house_name
			$this->SetSearchParm($p_players->registration_date); // registration_date
			$this->SetSearchParm($p_players->gold_num); // gold_num
			$this->SetSearchParm($p_players->agent_for_players); // agent_for_players
			$this->SetSearchParm($p_players->my_agent_players); // my_agent_players
			$this->SetSearchParm($p_players->custom_links); // custom_links
			$this->SetSearchParm($p_players->medals); // medals
			$this->SetSearchParm($p_players->total_people_count); // total_people_count
			$this->SetSearchParm($p_players->selected_village_id); // selected_village_id
			$this->SetSearchParm($p_players->villages_count); // villages_count
			$this->SetSearchParm($p_players->villages_id); // villages_id
			$this->SetSearchParm($p_players->villages_data); // villages_data
			$this->SetSearchParm($p_players->friend_players); // friend_players
			$this->SetSearchParm($p_players->notes); // notes
			$this->SetSearchParm($p_players->hero_troop_id); // hero_troop_id
			$this->SetSearchParm($p_players->hero_level); // hero_level
			$this->SetSearchParm($p_players->hero_points); // hero_points
			$this->SetSearchParm($p_players->hero_name); // hero_name
			$this->SetSearchParm($p_players->attack_points); // attack_points
			$this->SetSearchParm($p_players->defense_points); // defense_points
			$this->SetSearchParm($p_players->week_attack_points); // week_attack_points
			$this->SetSearchParm($p_players->week_defense_points); // week_defense_points
			$this->SetSearchParm($p_players->week_dev_points); // week_dev_points
			$this->SetSearchParm($p_players->week_thief_points); // week_thief_points
		}
		return $sWhere;
	}

	// Build search SQL
	function BuildSearchSql(&$Where, &$Fld, $MultiValue) {
		$FldParm = substr($Fld->FldVar, 2);		
		$FldVal = $Fld->AdvancedSearch->SearchValue; // @$_GET["x_$FldParm"]
		$FldOpr = $Fld->AdvancedSearch->SearchOperator; // @$_GET["z_$FldParm"]
		$FldCond = $Fld->AdvancedSearch->SearchCondition; // @$_GET["v_$FldParm"]
		$FldVal2 = $Fld->AdvancedSearch->SearchValue2; // @$_GET["y_$FldParm"]
		$FldOpr2 = $Fld->AdvancedSearch->SearchOperator2; // @$_GET["w_$FldParm"]
		$sWrk = "";

		//$FldVal = ew_StripSlashes($FldVal);
		if (is_array($FldVal)) $FldVal = implode(",", $FldVal);

		//$FldVal2 = ew_StripSlashes($FldVal2);
		if (is_array($FldVal2)) $FldVal2 = implode(",", $FldVal2);
		$FldOpr = strtoupper(trim($FldOpr));
		if ($FldOpr == "") $FldOpr = "=";
		$FldOpr2 = strtoupper(trim($FldOpr2));
		if ($FldOpr2 == "") $FldOpr2 = "=";
		if (EW_SEARCH_MULTI_VALUE_OPTION == 1 || $FldOpr <> "LIKE" ||
			($FldOpr2 <> "LIKE" && $FldVal2 <> ""))
			$MultiValue = FALSE;
		if ($MultiValue) {
			$sWrk1 = ($FldVal <> "") ? ew_GetMultiSearchSql($Fld, $FldVal) : ""; // Field value 1
			$sWrk2 = ($FldVal2 <> "") ? ew_GetMultiSearchSql($Fld, $FldVal2) : ""; // Field value 2
			$sWrk = $sWrk1; // Build final SQL
			if ($sWrk2 <> "")
				$sWrk = ($sWrk <> "") ? "($sWrk) $FldCond ($sWrk2)" : $sWrk2;
		} else {
			$FldVal = $this->ConvertSearchValue($Fld, $FldVal);
			$FldVal2 = $this->ConvertSearchValue($Fld, $FldVal2);
			$sWrk = ew_GetSearchSql($Fld, $FldVal, $FldOpr, $FldCond, $FldVal2, $FldOpr2);
		}
		if ($sWrk <> "") {
			if ($Where <> "") $Where .= " AND ";
			$Where .= "(" . $sWrk . ")";
		}
	}

	// Set search parameters
	function SetSearchParm(&$Fld) {
		global $p_players;
		$FldParm = substr($Fld->FldVar, 2);
		$FldVal = $Fld->AdvancedSearch->SearchValue; // @$_GET["x_$FldParm"]
		$FldVal = ew_StripSlashes($FldVal);
		if (is_array($FldVal)) $FldVal = implode(",", $FldVal);
		$FldVal2 = $Fld->AdvancedSearch->SearchValue2; // @$_GET["y_$FldParm"]
		$FldVal2 = ew_StripSlashes($FldVal2);
		if (is_array($FldVal2)) $FldVal2 = implode(",", $FldVal2);
		$p_players->setAdvancedSearch("x_$FldParm", $FldVal);
		$p_players->setAdvancedSearch("z_$FldParm", $Fld->AdvancedSearch->SearchOperator); // @$_GET["z_$FldParm"]
		$p_players->setAdvancedSearch("v_$FldParm", $Fld->AdvancedSearch->SearchCondition); // @$_GET["v_$FldParm"]
		$p_players->setAdvancedSearch("y_$FldParm", $FldVal2);
		$p_players->setAdvancedSearch("w_$FldParm", $Fld->AdvancedSearch->SearchOperator2); // @$_GET["w_$FldParm"]
	}

	// Get search parameters
	function GetSearchParm(&$Fld) {
		global $p_players;
		$FldParm = substr($Fld->FldVar, 2);
		$Fld->AdvancedSearch->SearchValue = $p_players->GetAdvancedSearch("x_$FldParm");
		$Fld->AdvancedSearch->SearchOperator = $p_players->GetAdvancedSearch("z_$FldParm");
		$Fld->AdvancedSearch->SearchCondition = $p_players->GetAdvancedSearch("v_$FldParm");
		$Fld->AdvancedSearch->SearchValue2 = $p_players->GetAdvancedSearch("y_$FldParm");
		$Fld->AdvancedSearch->SearchOperator2 = $p_players->GetAdvancedSearch("w_$FldParm");
	}

	// Convert search value
	function ConvertSearchValue(&$Fld, $FldVal) {
		$Value = $FldVal;
		if ($Fld->FldDataType == EW_DATATYPE_BOOLEAN) {
			if ($FldVal <> "") $Value = ($FldVal == "1") ? $Fld->TrueValue : $Fld->FalseValue;
		} elseif ($Fld->FldDataType == EW_DATATYPE_DATE) {
			if ($FldVal <> "") $Value = ew_UnFormatDateTime($FldVal, $Fld->FldDateTimeFormat);
		}
		return $Value;
	}

	// Return basic search SQL
	function BasicSearchSQL($Keyword) {
		global $p_players;
		$sKeyword = ew_AdjustSql($Keyword);
		$sWhere = "";
		$this->BuildBasicSearchSQL($sWhere, $p_players->name, $Keyword);
		$this->BuildBasicSearchSQL($sWhere, $p_players->zemail, $Keyword);
		if (is_numeric($Keyword)) $this->BuildBasicSearchSQL($sWhere, $p_players->active_plus_account, $Keyword);
		$this->BuildBasicSearchSQL($sWhere, $p_players->last_ip, $Keyword);
		if (is_numeric($Keyword)) $this->BuildBasicSearchSQL($sWhere, $p_players->total_people_count, $Keyword);
		return $sWhere;
	}

	// Build basic search SQL
	function BuildBasicSearchSql(&$Where, &$Fld, $Keyword) {
		$sFldExpression = ($Fld->FldVirtualExpression <> "") ? $Fld->FldVirtualExpression : $Fld->FldExpression;
		$lFldDataType = ($Fld->FldIsVirtual) ? EW_DATATYPE_STRING : $Fld->FldDataType;
		if ($lFldDataType == EW_DATATYPE_NUMBER) {
			$sWrk = $sFldExpression . " = " . ew_QuotedValue($Keyword, $lFldDataType);
		} else {
			$sWrk = $sFldExpression . " LIKE " . ew_QuotedValue("%" . $Keyword . "%", $lFldDataType);
		}
		if ($Where <> "") $Where .= " OR ";
		$Where .= $sWrk;
	}

	// Return basic search WHERE clause based on search keyword and type
	function BasicSearchWhere() {
		global $Security, $p_players;
		$sSearchStr = "";
		$sSearchKeyword = $p_players->BasicSearchKeyword;
		$sSearchType = $p_players->BasicSearchType;
		if ($sSearchKeyword <> "") {
			$sSearch = trim($sSearchKeyword);
			if ($sSearchType <> "") {
				while (strpos($sSearch, "  ") !== FALSE)
					$sSearch = str_replace("  ", " ", $sSearch);
				$arKeyword = explode(" ", trim($sSearch));
				foreach ($arKeyword as $sKeyword) {
					if ($sSearchStr <> "") $sSearchStr .= " " . $sSearchType . " ";
					$sSearchStr .= "(" . $this->BasicSearchSQL($sKeyword) . ")";
				}
			} else {
				$sSearchStr = $this->BasicSearchSQL($sSearch);
			}
		}
		if ($sSearchKeyword <> "") {
			$p_players->setSessionBasicSearchKeyword($sSearchKeyword);
			$p_players->setSessionBasicSearchType($sSearchType);
		}
		return $sSearchStr;
	}

	// Clear all search parameters
	function ResetSearchParms() {
		global $p_players;

		// Clear search WHERE clause
		$this->sSrchWhere = "";
		$p_players->setSearchWhere($this->sSrchWhere);

		// Clear basic search parameters
		$this->ResetBasicSearchParms();

		// Clear advanced search parameters
		$this->ResetAdvancedSearchParms();
	}

	// Clear all basic search parameters
	function ResetBasicSearchParms() {
		global $p_players;
		$p_players->setSessionBasicSearchKeyword("");
		$p_players->setSessionBasicSearchType("");
	}

	// Clear all advanced search parameters
	function ResetAdvancedSearchParms() {
		global $p_players;
		$p_players->setAdvancedSearch("x_id", "");
		$p_players->setAdvancedSearch("x_name", "");
		$p_players->setAdvancedSearch("x_zemail", "");
		$p_players->setAdvancedSearch("x_is_active", "");
		$p_players->setAdvancedSearch("x_active_plus_account", "");
		$p_players->setAdvancedSearch("x_activation_code", "");
		$p_players->setAdvancedSearch("x_last_ip", "");
		$p_players->setAdvancedSearch("x_description1", "");
		$p_players->setAdvancedSearch("x_description2", "");
		$p_players->setAdvancedSearch("x_house_name", "");
		$p_players->setAdvancedSearch("x_registration_date", "");
		$p_players->setAdvancedSearch("x_gold_num", "");
		$p_players->setAdvancedSearch("x_agent_for_players", "");
		$p_players->setAdvancedSearch("x_my_agent_players", "");
		$p_players->setAdvancedSearch("x_custom_links", "");
		$p_players->setAdvancedSearch("x_medals", "");
		$p_players->setAdvancedSearch("x_total_people_count", "");
		$p_players->setAdvancedSearch("x_selected_village_id", "");
		$p_players->setAdvancedSearch("x_villages_count", "");
		$p_players->setAdvancedSearch("x_villages_id", "");
		$p_players->setAdvancedSearch("x_villages_data", "");
		$p_players->setAdvancedSearch("x_friend_players", "");
		$p_players->setAdvancedSearch("x_notes", "");
		$p_players->setAdvancedSearch("x_hero_troop_id", "");
		$p_players->setAdvancedSearch("x_hero_level", "");
		$p_players->setAdvancedSearch("x_hero_points", "");
		$p_players->setAdvancedSearch("x_hero_name", "");
		$p_players->setAdvancedSearch("x_attack_points", "");
		$p_players->setAdvancedSearch("x_defense_points", "");
		$p_players->setAdvancedSearch("x_week_attack_points", "");
		$p_players->setAdvancedSearch("x_week_defense_points", "");
		$p_players->setAdvancedSearch("x_week_dev_points", "");
		$p_players->setAdvancedSearch("x_week_thief_points", "");
	}

	// Restore all search parameters
	function RestoreSearchParms() {
		global $p_players;
		$bRestore = TRUE;
		if (@$_GET[EW_TABLE_BASIC_SEARCH] <> "") $bRestore = FALSE;
		if (@$_GET["x_id"] <> "") $bRestore = FALSE;
		if (@$_GET["x_name"] <> "") $bRestore = FALSE;
		if (@$_GET["x_zemail"] <> "") $bRestore = FALSE;
		if (@$_GET["x_is_active"] <> "") $bRestore = FALSE;
		if (@$_GET["x_active_plus_account"] <> "") $bRestore = FALSE;
		if (@$_GET["x_activation_code"] <> "") $bRestore = FALSE;
		if (@$_GET["x_last_ip"] <> "") $bRestore = FALSE;
		if (@$_GET["x_description1"] <> "") $bRestore = FALSE;
		if (@$_GET["x_description2"] <> "") $bRestore = FALSE;
		if (@$_GET["x_house_name"] <> "") $bRestore = FALSE;
		if (@$_GET["x_registration_date"] <> "") $bRestore = FALSE;
		if (@$_GET["x_gold_num"] <> "") $bRestore = FALSE;
		if (@$_GET["x_agent_for_players"] <> "") $bRestore = FALSE;
		if (@$_GET["x_my_agent_players"] <> "") $bRestore = FALSE;
		if (@$_GET["x_custom_links"] <> "") $bRestore = FALSE;
		if (@$_GET["x_medals"] <> "") $bRestore = FALSE;
		if (@$_GET["x_total_people_count"] <> "") $bRestore = FALSE;
		if (@$_GET["x_selected_village_id"] <> "") $bRestore = FALSE;
		if (@$_GET["x_villages_count"] <> "") $bRestore = FALSE;
		if (@$_GET["x_villages_id"] <> "") $bRestore = FALSE;
		if (@$_GET["x_villages_data"] <> "") $bRestore = FALSE;
		if (@$_GET["x_friend_players"] <> "") $bRestore = FALSE;
		if (@$_GET["x_notes"] <> "") $bRestore = FALSE;
		if (@$_GET["x_hero_troop_id"] <> "") $bRestore = FALSE;
		if (@$_GET["x_hero_level"] <> "") $bRestore = FALSE;
		if (@$_GET["x_hero_points"] <> "") $bRestore = FALSE;
		if (@$_GET["x_hero_name"] <> "") $bRestore = FALSE;
		if (@$_GET["x_attack_points"] <> "") $bRestore = FALSE;
		if (@$_GET["x_defense_points"] <> "") $bRestore = FALSE;
		if (@$_GET["x_week_attack_points"] <> "") $bRestore = FALSE;
		if (@$_GET["x_week_defense_points"] <> "") $bRestore = FALSE;
		if (@$_GET["x_week_dev_points"] <> "") $bRestore = FALSE;
		if (@$_GET["x_week_thief_points"] <> "") $bRestore = FALSE;
		$this->RestoreSearch = $bRestore;
		if ($bRestore) {

			// Restore basic search values
			$p_players->BasicSearchKeyword = $p_players->getSessionBasicSearchKeyword();
			$p_players->BasicSearchType = $p_players->getSessionBasicSearchType();

			// Restore advanced search values
			$this->GetSearchParm($p_players->id);
			$this->GetSearchParm($p_players->name);
			$this->GetSearchParm($p_players->zemail);
			$this->GetSearchParm($p_players->is_active);
			$this->GetSearchParm($p_players->active_plus_account);
			$this->GetSearchParm($p_players->activation_code);
			$this->GetSearchParm($p_players->last_ip);
			$this->GetSearchParm($p_players->description1);
			$this->GetSearchParm($p_players->description2);
			$this->GetSearchParm($p_players->house_name);
			$this->GetSearchParm($p_players->registration_date);
			$this->GetSearchParm($p_players->gold_num);
			$this->GetSearchParm($p_players->agent_for_players);
			$this->GetSearchParm($p_players->my_agent_players);
			$this->GetSearchParm($p_players->custom_links);
			$this->GetSearchParm($p_players->medals);
			$this->GetSearchParm($p_players->total_people_count);
			$this->GetSearchParm($p_players->selected_village_id);
			$this->GetSearchParm($p_players->villages_count);
			$this->GetSearchParm($p_players->villages_id);
			$this->GetSearchParm($p_players->villages_data);
			$this->GetSearchParm($p_players->friend_players);
			$this->GetSearchParm($p_players->notes);
			$this->GetSearchParm($p_players->hero_troop_id);
			$this->GetSearchParm($p_players->hero_level);
			$this->GetSearchParm($p_players->hero_points);
			$this->GetSearchParm($p_players->hero_name);
			$this->GetSearchParm($p_players->attack_points);
			$this->GetSearchParm($p_players->defense_points);
			$this->GetSearchParm($p_players->week_attack_points);
			$this->GetSearchParm($p_players->week_defense_points);
			$this->GetSearchParm($p_players->week_dev_points);
			$this->GetSearchParm($p_players->week_thief_points);
		}
	}

	// Set up sort parameters
	function SetUpSortOrder() {
		global $p_players;

		// Check for "order" parameter
		if (@$_GET["order"] <> "") {
			$p_players->CurrentOrder = ew_StripSlashes(@$_GET["order"]);
			$p_players->CurrentOrderType = @$_GET["ordertype"];
			$p_players->UpdateSort($p_players->id); // id
			$p_players->UpdateSort($p_players->name); // name
			$p_players->UpdateSort($p_players->zemail); // email
			$p_players->UpdateSort($p_players->is_active); // is_active
			$p_players->UpdateSort($p_players->active_plus_account); // active_plus_account
			$p_players->UpdateSort($p_players->last_ip); // last_ip
			$p_players->UpdateSort($p_players->gold_num); // gold_num
			$p_players->UpdateSort($p_players->total_people_count); // total_people_count
			$p_players->setStartRecordNumber(1); // Reset start position
		}
	}

	// Load sort order parameters
	function LoadSortOrder() {
		global $p_players;
		$sOrderBy = $p_players->getSessionOrderBy(); // Get ORDER BY from Session
		if ($sOrderBy == "") {
			if ($p_players->SqlOrderBy() <> "") {
				$sOrderBy = $p_players->SqlOrderBy();
				$p_players->setSessionOrderBy($sOrderBy);
			}
		}
	}

	// Reset command
	// cmd=reset (Reset search parameters)
	// cmd=resetall (Reset search and master/detail parameters)
	// cmd=resetsort (Reset sort parameters)
	function ResetCmd() {
		global $p_players;

		// Get reset command
		if (@$_GET["cmd"] <> "") {
			$sCmd = $_GET["cmd"];

			// Reset search criteria
			if (strtolower($sCmd) == "reset" || strtolower($sCmd) == "resetall")
				$this->ResetSearchParms();

			// Reset sorting order
			if (strtolower($sCmd) == "resetsort") {
				$sOrderBy = "";
				$p_players->setSessionOrderBy($sOrderBy);
				$p_players->id->setSort("");
				$p_players->name->setSort("");
				$p_players->zemail->setSort("");
				$p_players->is_active->setSort("");
				$p_players->active_plus_account->setSort("");
				$p_players->last_ip->setSort("");
				$p_players->gold_num->setSort("");
				$p_players->total_people_count->setSort("");
			}

			// Reset start position
			$this->lStartRec = 1;
			$p_players->setStartRecordNumber($this->lStartRec);
		}
	}

	// Set up list options
	function SetupListOptions() {
		global $Security, $p_players;

		// "view"
		$this->ListOptions->Add("view");
		$item =& $this->ListOptions->Items["view"];
		$item->CssStyle = "white-space: nowrap;";
		$item->Visible = $Security->IsLoggedIn();
		$item->OnLeft = FALSE;

		// "edit"
		$this->ListOptions->Add("edit");
		$item =& $this->ListOptions->Items["edit"];
		$item->CssStyle = "white-space: nowrap;";
		$item->Visible = $Security->IsLoggedIn();
		$item->OnLeft = FALSE;

		// Call ListOptions_Load event
		$this->ListOptions_Load();
		if ($p_players->Export <> "" ||
			$p_players->CurrentAction == "gridadd" ||
			$p_players->CurrentAction == "gridedit")
			$this->ListOptions->HideAllOptions();
	}

	// Render list options
	function RenderListOptions() {
		global $Security, $Language, $p_players;
		$this->ListOptions->LoadDefault();

		// "view"
		$oListOpt =& $this->ListOptions->Items["view"];
		if ($Security->IsLoggedIn() && $oListOpt->Visible)
			$oListOpt->Body = "<a href=\"" . $this->ViewUrl . "\">" . $Language->Phrase("ViewLink") . "</a>";

		// "edit"
		$oListOpt =& $this->ListOptions->Items["edit"];
		if ($Security->IsLoggedIn() && $oListOpt->Visible) {
			$oListOpt->Body = "<a href=\"" . $this->EditUrl . "\">" . $Language->Phrase("EditLink") . "</a>";
		}
		$this->RenderListOptionsExt();

		// Call ListOptions_Rendered event
		$this->ListOptions_Rendered();
	}

	function RenderListOptionsExt() {
		global $Security, $Language, $p_players;
	}

	// Set up starting record parameters
	function SetUpStartRec() {
		global $p_players;
		if ($this->lDisplayRecs == 0)
			return;
		if ($this->IsPageRequest()) { // Validate request
			if (@$_GET[EW_TABLE_START_REC] <> "") { // Check for "start" parameter
				$this->lStartRec = $_GET[EW_TABLE_START_REC];
				$p_players->setStartRecordNumber($this->lStartRec);
			} elseif (@$_GET[EW_TABLE_PAGE_NO] <> "") {
				$this->nPageNo = $_GET[EW_TABLE_PAGE_NO];
				if (is_numeric($this->nPageNo)) {
					$this->lStartRec = ($this->nPageNo-1)*$this->lDisplayRecs+1;
					if ($this->lStartRec <= 0) {
						$this->lStartRec = 1;
					} elseif ($this->lStartRec >= intval(($this->lTotalRecs-1)/$this->lDisplayRecs)*$this->lDisplayRecs+1) {
						$this->lStartRec = intval(($this->lTotalRecs-1)/$this->lDisplayRecs)*$this->lDisplayRecs+1;
					}
					$p_players->setStartRecordNumber($this->lStartRec);
				}
			}
		}
		$this->lStartRec = $p_players->getStartRecordNumber();

		// Check if correct start record counter
		if (!is_numeric($this->lStartRec) || $this->lStartRec == "") { // Avoid invalid start record counter
			$this->lStartRec = 1; // Reset start record counter
			$p_players->setStartRecordNumber($this->lStartRec);
		} elseif (intval($this->lStartRec) > intval($this->lTotalRecs)) { // Avoid starting record > total records
			$this->lStartRec = intval(($this->lTotalRecs-1)/$this->lDisplayRecs)*$this->lDisplayRecs+1; // Point to last page first record
			$p_players->setStartRecordNumber($this->lStartRec);
		} elseif (($this->lStartRec-1) % $this->lDisplayRecs <> 0) {
			$this->lStartRec = intval(($this->lStartRec-1)/$this->lDisplayRecs)*$this->lDisplayRecs+1; // Point to page boundary
			$p_players->setStartRecordNumber($this->lStartRec);
		}
	}

	// Load basic search values
	function LoadBasicSearchValues() {
		global $p_players;
		$p_players->BasicSearchKeyword = @$_GET[EW_TABLE_BASIC_SEARCH];
		$p_players->BasicSearchType = @$_GET[EW_TABLE_BASIC_SEARCH_TYPE];
	}

	//  Load search values for validation
	function LoadSearchValues() {
		global $objForm, $p_players;

		// Load search values
		// id

		$p_players->id->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_id"]);
		$p_players->id->AdvancedSearch->SearchOperator = @$_GET["z_id"];

		// name
		$p_players->name->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_name"]);
		$p_players->name->AdvancedSearch->SearchOperator = @$_GET["z_name"];

		// email
		$p_players->zemail->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_zemail"]);
		$p_players->zemail->AdvancedSearch->SearchOperator = @$_GET["z_zemail"];

		// is_active
		$p_players->is_active->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_is_active"]);
		$p_players->is_active->AdvancedSearch->SearchOperator = @$_GET["z_is_active"];

		// active_plus_account
		$p_players->active_plus_account->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_active_plus_account"]);
		$p_players->active_plus_account->AdvancedSearch->SearchOperator = @$_GET["z_active_plus_account"];

		// activation_code
		$p_players->activation_code->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_activation_code"]);
		$p_players->activation_code->AdvancedSearch->SearchOperator = @$_GET["z_activation_code"];

		// last_ip
		$p_players->last_ip->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_last_ip"]);
		$p_players->last_ip->AdvancedSearch->SearchOperator = @$_GET["z_last_ip"];

		// description1
		$p_players->description1->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_description1"]);
		$p_players->description1->AdvancedSearch->SearchOperator = @$_GET["z_description1"];

		// description2
		$p_players->description2->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_description2"]);
		$p_players->description2->AdvancedSearch->SearchOperator = @$_GET["z_description2"];

		// house_name
		$p_players->house_name->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_house_name"]);
		$p_players->house_name->AdvancedSearch->SearchOperator = @$_GET["z_house_name"];

		// registration_date
		$p_players->registration_date->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_registration_date"]);
		$p_players->registration_date->AdvancedSearch->SearchOperator = @$_GET["z_registration_date"];

		// gold_num
		$p_players->gold_num->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_gold_num"]);
		$p_players->gold_num->AdvancedSearch->SearchOperator = @$_GET["z_gold_num"];

		// agent_for_players
		$p_players->agent_for_players->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_agent_for_players"]);
		$p_players->agent_for_players->AdvancedSearch->SearchOperator = @$_GET["z_agent_for_players"];

		// my_agent_players
		$p_players->my_agent_players->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_my_agent_players"]);
		$p_players->my_agent_players->AdvancedSearch->SearchOperator = @$_GET["z_my_agent_players"];

		// custom_links
		$p_players->custom_links->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_custom_links"]);
		$p_players->custom_links->AdvancedSearch->SearchOperator = @$_GET["z_custom_links"];

		// medals
		$p_players->medals->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_medals"]);
		$p_players->medals->AdvancedSearch->SearchOperator = @$_GET["z_medals"];

		// total_people_count
		$p_players->total_people_count->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_total_people_count"]);
		$p_players->total_people_count->AdvancedSearch->SearchOperator = @$_GET["z_total_people_count"];

		// selected_village_id
		$p_players->selected_village_id->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_selected_village_id"]);
		$p_players->selected_village_id->AdvancedSearch->SearchOperator = @$_GET["z_selected_village_id"];

		// villages_count
		$p_players->villages_count->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_villages_count"]);
		$p_players->villages_count->AdvancedSearch->SearchOperator = @$_GET["z_villages_count"];

		// villages_id
		$p_players->villages_id->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_villages_id"]);
		$p_players->villages_id->AdvancedSearch->SearchOperator = @$_GET["z_villages_id"];

		// villages_data
		$p_players->villages_data->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_villages_data"]);
		$p_players->villages_data->AdvancedSearch->SearchOperator = @$_GET["z_villages_data"];

		// friend_players
		$p_players->friend_players->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_friend_players"]);
		$p_players->friend_players->AdvancedSearch->SearchOperator = @$_GET["z_friend_players"];

		// notes
		$p_players->notes->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_notes"]);
		$p_players->notes->AdvancedSearch->SearchOperator = @$_GET["z_notes"];

		// hero_troop_id
		$p_players->hero_troop_id->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_hero_troop_id"]);
		$p_players->hero_troop_id->AdvancedSearch->SearchOperator = @$_GET["z_hero_troop_id"];

		// hero_level
		$p_players->hero_level->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_hero_level"]);
		$p_players->hero_level->AdvancedSearch->SearchOperator = @$_GET["z_hero_level"];

		// hero_points
		$p_players->hero_points->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_hero_points"]);
		$p_players->hero_points->AdvancedSearch->SearchOperator = @$_GET["z_hero_points"];

		// hero_name
		$p_players->hero_name->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_hero_name"]);
		$p_players->hero_name->AdvancedSearch->SearchOperator = @$_GET["z_hero_name"];

		// attack_points
		$p_players->attack_points->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_attack_points"]);
		$p_players->attack_points->AdvancedSearch->SearchOperator = @$_GET["z_attack_points"];

		// defense_points
		$p_players->defense_points->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_defense_points"]);
		$p_players->defense_points->AdvancedSearch->SearchOperator = @$_GET["z_defense_points"];

		// week_attack_points
		$p_players->week_attack_points->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_week_attack_points"]);
		$p_players->week_attack_points->AdvancedSearch->SearchOperator = @$_GET["z_week_attack_points"];

		// week_defense_points
		$p_players->week_defense_points->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_week_defense_points"]);
		$p_players->week_defense_points->AdvancedSearch->SearchOperator = @$_GET["z_week_defense_points"];

		// week_dev_points
		$p_players->week_dev_points->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_week_dev_points"]);
		$p_players->week_dev_points->AdvancedSearch->SearchOperator = @$_GET["z_week_dev_points"];

		// week_thief_points
		$p_players->week_thief_points->AdvancedSearch->SearchValue = ew_StripSlashes(@$_GET["x_week_thief_points"]);
		$p_players->week_thief_points->AdvancedSearch->SearchOperator = @$_GET["z_week_thief_points"];
	}

	// Load recordset
	function LoadRecordset($offset = -1, $rowcnt = -1) {
		global $conn, $p_players;

		// Call Recordset Selecting event
		$p_players->Recordset_Selecting($p_players->CurrentFilter);

		// Load List page SQL
		$sSql = $p_players->SelectSQL();
		if ($offset > -1 && $rowcnt > -1)
			$sSql .= " LIMIT $offset, $rowcnt";

		// Load recordset
		$rs = ew_LoadRecordset($sSql);

		// Call Recordset Selected event
		$p_players->Recordset_Selected($rs);
		return $rs;
	}

	// Load row based on key values
	function LoadRow() {
		global $conn, $Security, $p_players;
		$sFilter = $p_players->KeyFilter();

		// Call Row Selecting event
		$p_players->Row_Selecting($sFilter);

		// Load SQL based on filter
		$p_players->CurrentFilter = $sFilter;
		$sSql = $p_players->SQL();
		$res = FALSE;
		$rs = ew_LoadRecordset($sSql);
		if ($rs && !$rs->EOF) {
			$res = TRUE;
			$this->LoadRowValues($rs); // Load row values

			// Call Row Selected event
			$p_players->Row_Selected($rs);
			$rs->Close();
		}
		return $res;
	}

	// Load row values from recordset
	function LoadRowValues(&$rs) {
		global $conn, $p_players;
		$p_players->id->setDbValue($rs->fields('id'));
		$p_players->tribe_id->setDbValue($rs->fields('tribe_id'));
		$p_players->alliance_id->setDbValue($rs->fields('alliance_id'));
		$p_players->alliance_name->setDbValue($rs->fields('alliance_name'));
		$p_players->alliance_roles->setDbValue($rs->fields('alliance_roles'));
		$p_players->invites_alliance_ids->setDbValue($rs->fields('invites_alliance_ids'));
		$p_players->name->setDbValue($rs->fields('name'));
		$p_players->pwd->setDbValue($rs->fields('pwd'));
		$p_players->zemail->setDbValue($rs->fields('email'));
		$p_players->is_active->setDbValue($rs->fields('is_active'));
		$p_players->is_blocked->setDbValue($rs->fields('is_blocked'));
		$p_players->player_type->setDbValue($rs->fields('player_type'));
		$p_players->active_plus_account->setDbValue($rs->fields('active_plus_account'));
		$p_players->activation_code->setDbValue($rs->fields('activation_code'));
		$p_players->last_login_date->setDbValue($rs->fields('last_login_date'));
		$p_players->last_ip->setDbValue($rs->fields('last_ip'));
		$p_players->birth_date->setDbValue($rs->fields('birth_date'));
		$p_players->gender->setDbValue($rs->fields('gender'));
		$p_players->description1->setDbValue($rs->fields('description1'));
		$p_players->description2->setDbValue($rs->fields('description2'));
		$p_players->house_name->setDbValue($rs->fields('house_name'));
		$p_players->registration_date->setDbValue($rs->fields('registration_date'));
		$p_players->gold_num->setDbValue($rs->fields('gold_num'));
		$p_players->agent_for_players->setDbValue($rs->fields('agent_for_players'));
		$p_players->my_agent_players->setDbValue($rs->fields('my_agent_players'));
		$p_players->custom_links->setDbValue($rs->fields('custom_links'));
		$p_players->medals->setDbValue($rs->fields('medals'));
		$p_players->total_people_count->setDbValue($rs->fields('total_people_count'));
		$p_players->selected_village_id->setDbValue($rs->fields('selected_village_id'));
		$p_players->villages_count->setDbValue($rs->fields('villages_count'));
		$p_players->villages_id->setDbValue($rs->fields('villages_id'));
		$p_players->villages_data->setDbValue($rs->fields('villages_data'));
		$p_players->friend_players->setDbValue($rs->fields('friend_players'));
		$p_players->notes->setDbValue($rs->fields('notes'));
		$p_players->hero_troop_id->setDbValue($rs->fields('hero_troop_id'));
		$p_players->hero_level->setDbValue($rs->fields('hero_level'));
		$p_players->hero_points->setDbValue($rs->fields('hero_points'));
		$p_players->hero_name->setDbValue($rs->fields('hero_name'));
		$p_players->hero_in_village_id->setDbValue($rs->fields('hero_in_village_id'));
		$p_players->attack_points->setDbValue($rs->fields('attack_points'));
		$p_players->defense_points->setDbValue($rs->fields('defense_points'));
		$p_players->week_attack_points->setDbValue($rs->fields('week_attack_points'));
		$p_players->week_defense_points->setDbValue($rs->fields('week_defense_points'));
		$p_players->week_dev_points->setDbValue($rs->fields('week_dev_points'));
		$p_players->week_thief_points->setDbValue($rs->fields('week_thief_points'));
		$p_players->new_report_count->setDbValue($rs->fields('new_report_count'));
		$p_players->new_mail_count->setDbValue($rs->fields('new_mail_count'));
		$p_players->guide_quiz->setDbValue($rs->fields('guide_quiz'));
	}

	// Render row values based on field settings
	function RenderRow() {
		global $conn, $Security, $Language, $p_players;

		// Initialize URLs
		$this->ViewUrl = $p_players->ViewUrl();
		$this->EditUrl = $p_players->EditUrl();
		$this->InlineEditUrl = $p_players->InlineEditUrl();
		$this->CopyUrl = $p_players->CopyUrl();
		$this->InlineCopyUrl = $p_players->InlineCopyUrl();
		$this->DeleteUrl = $p_players->DeleteUrl();

		// Call Row_Rendering event
		$p_players->Row_Rendering();

		// Common render codes for all row types
		// id

		$p_players->id->CellCssStyle = ""; $p_players->id->CellCssClass = "";
		$p_players->id->CellAttrs = array(); $p_players->id->ViewAttrs = array(); $p_players->id->EditAttrs = array();

		// name
		$p_players->name->CellCssStyle = ""; $p_players->name->CellCssClass = "";
		$p_players->name->CellAttrs = array(); $p_players->name->ViewAttrs = array(); $p_players->name->EditAttrs = array();

		// email
		$p_players->zemail->CellCssStyle = ""; $p_players->zemail->CellCssClass = "";
		$p_players->zemail->CellAttrs = array(); $p_players->zemail->ViewAttrs = array(); $p_players->zemail->EditAttrs = array();

		// is_active
		$p_players->is_active->CellCssStyle = ""; $p_players->is_active->CellCssClass = "";
		$p_players->is_active->CellAttrs = array(); $p_players->is_active->ViewAttrs = array(); $p_players->is_active->EditAttrs = array();

		// active_plus_account
		$p_players->active_plus_account->CellCssStyle = ""; $p_players->active_plus_account->CellCssClass = "";
		$p_players->active_plus_account->CellAttrs = array(); $p_players->active_plus_account->ViewAttrs = array(); $p_players->active_plus_account->EditAttrs = array();

		// last_ip
		$p_players->last_ip->CellCssStyle = ""; $p_players->last_ip->CellCssClass = "";
		$p_players->last_ip->CellAttrs = array(); $p_players->last_ip->ViewAttrs = array(); $p_players->last_ip->EditAttrs = array();

		// gold_num
		$p_players->gold_num->CellCssStyle = ""; $p_players->gold_num->CellCssClass = "";
		$p_players->gold_num->CellAttrs = array(); $p_players->gold_num->ViewAttrs = array(); $p_players->gold_num->EditAttrs = array();

		// total_people_count
		$p_players->total_people_count->CellCssStyle = ""; $p_players->total_people_count->CellCssClass = "";
		$p_players->total_people_count->CellAttrs = array(); $p_players->total_people_count->ViewAttrs = array(); $p_players->total_people_count->EditAttrs = array();
		if ($p_players->RowType == EW_ROWTYPE_VIEW) { // View row

			// id
			$p_players->id->ViewValue = $p_players->id->CurrentValue;
			$p_players->id->CssStyle = "";
			$p_players->id->CssClass = "";
			$p_players->id->ViewCustomAttributes = "";

			// name
			$p_players->name->ViewValue = $p_players->name->CurrentValue;
			$p_players->name->CssStyle = "";
			$p_players->name->CssClass = "";
			$p_players->name->ViewCustomAttributes = "";

			// email
			$p_players->zemail->ViewValue = $p_players->zemail->CurrentValue;
			$p_players->zemail->CssStyle = "";
			$p_players->zemail->CssClass = "";
			$p_players->zemail->ViewCustomAttributes = "";

			// is_active
			$p_players->is_active->ViewValue = $p_players->is_active->CurrentValue;
			$p_players->is_active->CssStyle = "";
			$p_players->is_active->CssClass = "";
			$p_players->is_active->ViewCustomAttributes = "";

			// active_plus_account
			$p_players->active_plus_account->ViewValue = $p_players->active_plus_account->CurrentValue;
			$p_players->active_plus_account->CssStyle = "";
			$p_players->active_plus_account->CssClass = "";
			$p_players->active_plus_account->ViewCustomAttributes = "";

			// last_ip
			$p_players->last_ip->ViewValue = $p_players->last_ip->CurrentValue;
			$p_players->last_ip->CssStyle = "";
			$p_players->last_ip->CssClass = "";
			$p_players->last_ip->ViewCustomAttributes = "";

			// gold_num
			$p_players->gold_num->ViewValue = $p_players->gold_num->CurrentValue;
			$p_players->gold_num->CssStyle = "";
			$p_players->gold_num->CssClass = "";
			$p_players->gold_num->ViewCustomAttributes = "";

			// total_people_count
			$p_players->total_people_count->ViewValue = $p_players->total_people_count->CurrentValue;
			$p_players->total_people_count->CssStyle = "";
			$p_players->total_people_count->CssClass = "";
			$p_players->total_people_count->ViewCustomAttributes = "";

			// id
			$p_players->id->HrefValue = "";
			$p_players->id->TooltipValue = "";

			// name
			$p_players->name->HrefValue = "";
			$p_players->name->TooltipValue = "";

			// email
			$p_players->zemail->HrefValue = "";
			$p_players->zemail->TooltipValue = "";

			// is_active
			$p_players->is_active->HrefValue = "";
			$p_players->is_active->TooltipValue = "";

			// active_plus_account
			$p_players->active_plus_account->HrefValue = "";
			$p_players->active_plus_account->TooltipValue = "";

			// last_ip
			$p_players->last_ip->HrefValue = "";
			$p_players->last_ip->TooltipValue = "";

			// gold_num
			$p_players->gold_num->HrefValue = "";
			$p_players->gold_num->TooltipValue = "";

			// total_people_count
			$p_players->total_people_count->HrefValue = "";
			$p_players->total_people_count->TooltipValue = "";
		} elseif ($p_players->RowType == EW_ROWTYPE_SEARCH) { // Search row

			// id
			$p_players->id->EditCustomAttributes = "";
			$p_players->id->EditValue = ew_HtmlEncode($p_players->id->AdvancedSearch->SearchValue);

			// name
			$p_players->name->EditCustomAttributes = "";
			$p_players->name->EditValue = ew_HtmlEncode($p_players->name->AdvancedSearch->SearchValue);

			// email
			$p_players->zemail->EditCustomAttributes = "";
			$p_players->zemail->EditValue = ew_HtmlEncode($p_players->zemail->AdvancedSearch->SearchValue);

			// is_active
			$p_players->is_active->EditCustomAttributes = "";
			$p_players->is_active->EditValue = ew_HtmlEncode($p_players->is_active->AdvancedSearch->SearchValue);

			// active_plus_account
			$p_players->active_plus_account->EditCustomAttributes = "";
			$p_players->active_plus_account->EditValue = ew_HtmlEncode($p_players->active_plus_account->AdvancedSearch->SearchValue);

			// last_ip
			$p_players->last_ip->EditCustomAttributes = "";
			$p_players->last_ip->EditValue = ew_HtmlEncode($p_players->last_ip->AdvancedSearch->SearchValue);

			// gold_num
			$p_players->gold_num->EditCustomAttributes = "";
			$p_players->gold_num->EditValue = ew_HtmlEncode($p_players->gold_num->AdvancedSearch->SearchValue);

			// total_people_count
			$p_players->total_people_count->EditCustomAttributes = "";
			$p_players->total_people_count->EditValue = ew_HtmlEncode($p_players->total_people_count->AdvancedSearch->SearchValue);
		}

		// Call Row Rendered event
		if ($p_players->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$p_players->Row_Rendered();
	}

	// Validate search
	function ValidateSearch() {
		global $gsSearchError, $p_players;

		// Initialize
		$gsSearchError = "";

		// Check if validation required
		if (!EW_SERVER_VALIDATE)
			return TRUE;
		if (!ew_CheckInteger($p_players->id->AdvancedSearch->SearchValue)) {
			if ($gsSearchError <> "") $gsSearchError .= "<br>";
			$gsSearchError .= $p_players->id->FldErrMsg();
		}

		// Return validate result
		$ValidateSearch = ($gsSearchError == "");

		// Call Form_CustomValidate event
		$sFormCustomError = "";
		$ValidateSearch = $ValidateSearch && $this->Form_CustomValidate($sFormCustomError);
		if ($sFormCustomError <> "") {
			if ($gsSearchError <> "") $gsSearchError .= "<br>";
			$gsSearchError .= $sFormCustomError;
		}
		return $ValidateSearch;
	}

	// Load advanced search
	function LoadAdvancedSearch() {
		global $p_players;
		$p_players->id->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_id");
		$p_players->name->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_name");
		$p_players->zemail->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_zemail");
		$p_players->is_active->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_is_active");
		$p_players->active_plus_account->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_active_plus_account");
		$p_players->activation_code->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_activation_code");
		$p_players->last_ip->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_last_ip");
		$p_players->description1->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_description1");
		$p_players->description2->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_description2");
		$p_players->house_name->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_house_name");
		$p_players->registration_date->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_registration_date");
		$p_players->gold_num->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_gold_num");
		$p_players->agent_for_players->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_agent_for_players");
		$p_players->my_agent_players->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_my_agent_players");
		$p_players->custom_links->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_custom_links");
		$p_players->medals->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_medals");
		$p_players->total_people_count->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_total_people_count");
		$p_players->selected_village_id->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_selected_village_id");
		$p_players->villages_count->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_villages_count");
		$p_players->villages_id->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_villages_id");
		$p_players->villages_data->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_villages_data");
		$p_players->friend_players->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_friend_players");
		$p_players->notes->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_notes");
		$p_players->hero_troop_id->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_hero_troop_id");
		$p_players->hero_level->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_hero_level");
		$p_players->hero_points->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_hero_points");
		$p_players->hero_name->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_hero_name");
		$p_players->attack_points->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_attack_points");
		$p_players->defense_points->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_defense_points");
		$p_players->week_attack_points->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_week_attack_points");
		$p_players->week_defense_points->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_week_defense_points");
		$p_players->week_dev_points->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_week_dev_points");
		$p_players->week_thief_points->AdvancedSearch->SearchValue = $p_players->getAdvancedSearch("x_week_thief_points");
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	function Message_Showing(&$msg) {

		// Example:
		//$msg = "your new message";

	}

	// Form Custom Validate event
	function Form_CustomValidate(&$CustomError) {

		// Return error message in CustomError
		return TRUE;
	}

	// ListOptions Load event
	function ListOptions_Load() {

		// Example: 
		//$this->ListOptions->Add("new");
		//$this->ListOptions->Items["new"]->OnLeft = TRUE; // Link on left
		//$this->ListOptions->MoveItem("new", 0); // Move to first column

	}

	// ListOptions Rendered event
	function ListOptions_Rendered() {

		// Example: 
		//$this->ListOptions->Items["new"]->Body = "xxx";

	}
}
?>
